
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega128
;Program type             : Application
;Clock frequency          : 14,745600 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 1024 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4351
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x10FF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _TMR1H=R4
	.DEF _TMR1L=R6
	.DEF _TMR2=R8
	.DEF _ADC_A1=R10
	.DEF _ADC_A2=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer2_comp_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usart0_rx_isr
	JMP  0x00
	JMP  _usart0_tx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x0,0x80,0x34,0x43
_0x4:
	.DB  0x0,0x0,0x0,0x47
_0x5:
	.DB  0x6F,0x12,0x3,0x40
_0x6:
	.DB  0xA
_0x7:
	.DB  0x32
_0x8:
	.DB  0x66,0x66,0x3B,0xC2
_0x9:
	.DB  0x52,0xB8,0x2F,0x43
_0xA:
	.DB  0x0,0x0,0xC0,0xC0
_0xB:
	.DB  0x0,0x0,0xFA,0x42
_0xC:
	.DB  0x0,0x0,0x80,0x47
_0xD:
	.DB  0x0,0xFF,0x7F,0x47
_0xE:
	.DB  0x0,0x0,0x61,0x4B
_0x27:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
_0x0:
	.DB  0x4B,0x6F,0x6D,0x70,0x61,0x6B,0x74,0x6E
	.DB  0x69,0x20,0x73,0x6E,0x69,0x6D,0x61,0x63
	.DB  0x0,0x2D,0x2D,0x2D,0x4F,0x70,0x65,0x72
	.DB  0x61,0x74,0x69,0x76,0x6E,0x69,0x2D,0x2D
	.DB  0x2D,0x0,0x2D,0x2D,0x2D,0x2D,0x74,0x65
	.DB  0x70,0x6C,0x6F,0x74,0x79,0x2D,0x2D,0x2D
	.DB  0x2D,0x2D,0x0,0x20,0x43,0x65,0x6B,0x65
	.DB  0x6A,0x74,0x65,0x2E,0x2E,0x2E,0x20,0x25
	.DB  0x64,0x20,0x20,0x20,0x0,0x44,0x61,0x74
	.DB  0x65,0x20,0x25,0x30,0x32,0x64,0x2F,0x25
	.DB  0x30,0x32,0x64,0x2F,0x32,0x30,0x25,0x30
	.DB  0x32,0x64,0x20,0x0,0x54,0x69,0x6D,0x65
	.DB  0x20,0x25,0x30,0x32,0x64,0x3A,0x25,0x30
	.DB  0x32,0x64,0x3A,0x25,0x30,0x32,0x64,0x20
	.DB  0x20,0x20,0x0,0x4F,0x70,0x65,0x72,0x61
	.DB  0x74,0x69,0x76,0x6E,0x69,0x20,0x74,0x65
	.DB  0x70,0x6C,0x20,0x0,0x20,0x20,0x20,0x54
	.DB  0x6F,0x3A,0x20,0x25,0x73,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0x54,0x72,0x61,0x64,0x3A
	.DB  0x20,0x25,0x73,0x20,0x43,0x20,0x20,0x20
	.DB  0x20,0x0,0x54,0x6F,0x6B,0x6F,0x6C,0x3A
	.DB  0x20,0x25,0x73,0x20,0x43,0x20,0x20,0x20
	.DB  0x0,0x50,0x72,0x6F,0x75,0x64,0x3A,0x20
	.DB  0x25,0x73,0x20,0x6D,0x2F,0x73,0x20,0x0
	.DB  0x56,0x6C,0x68,0x6B,0x6F,0x73,0x74,0x3A
	.DB  0x20,0x25,0x73,0x20,0x25,0x25,0x20,0x0
	.DB  0x46,0x3A,0x20,0x25,0x73,0x20,0x48,0x7A
	.DB  0x20,0x20,0x20,0x0,0x4E,0x61,0x70,0x65
	.DB  0x74,0x69,0x5F,0x6F,0x6B,0x3A,0x25,0x73
	.DB  0x20,0x56,0x20,0x0,0x4E,0x61,0x70,0x65
	.DB  0x74,0x69,0x5F,0x72,0x61,0x3A,0x25,0x73
	.DB  0x20,0x56,0x0,0x54,0x65,0x70,0x6C,0x6F
	.DB  0x6B,0x6F,0x6C,0x69,0x3A,0x20,0x25,0x73
	.DB  0x20,0x0,0x41,0x44,0x43,0x5F,0x41,0x32
	.DB  0x3A,0x20,0x25,0x64,0x20,0x20,0x20,0x20
	.DB  0x0,0x41,0x44,0x43,0x5F,0x41,0x31,0x3A
	.DB  0x20,0x25,0x64,0x20,0x20,0x20,0x20,0x0
	.DB  0x53,0x48,0x54,0x5F,0x54,0x3A,0x20,0x25
	.DB  0x64,0x20,0x20,0x20,0x20,0x0,0x53,0x48
	.DB  0x54,0x5F,0x48,0x3A,0x20,0x25,0x64,0x20
	.DB  0x20,0x20,0x20,0x0,0x4E,0x61,0x73,0x74
	.DB  0x61,0x76,0x65,0x6E,0x69,0x20,0x63,0x61
	.DB  0x73,0x75,0x0,0x48,0x6F,0x64,0x69,0x6E
	.DB  0x79,0x3A,0x20,0x25,0x64,0x20,0x3C,0x20
	.DB  0x20,0x20,0x20,0x0,0x4D,0x69,0x6E,0x75
	.DB  0x74,0x79,0x3A,0x20,0x25,0x64,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x53,0x65
	.DB  0x6B,0x75,0x6E,0x64,0x79,0x3A,0x20,0x25
	.DB  0x64,0x20,0x20,0x20,0x20,0x20,0x0,0x48
	.DB  0x6F,0x64,0x69,0x6E,0x79,0x3A,0x20,0x25
	.DB  0x64,0x20,0x20,0x20,0x20,0x20,0x20,0x0
	.DB  0x4D,0x69,0x6E,0x75,0x74,0x79,0x3A,0x20
	.DB  0x25,0x64,0x20,0x3C,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x53,0x65,0x6B,0x75,0x6E,0x64
	.DB  0x79,0x3A,0x20,0x25,0x64,0x20,0x3C,0x20
	.DB  0x20,0x20,0x0,0x4E,0x61,0x73,0x74,0x61
	.DB  0x76,0x65,0x6E,0x69,0x20,0x64,0x61,0x74
	.DB  0x61,0x0,0x44,0x61,0x74,0x75,0x6D,0x3A
	.DB  0x20,0x25,0x64,0x20,0x3C,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0x4D,0x65,0x73,0x69,0x63
	.DB  0x3A,0x20,0x25,0x64,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x0,0x52,0x6F,0x6B,0x3A
	.DB  0x20,0x32,0x30,0x25,0x64,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x44,0x61,0x74
	.DB  0x75,0x6D,0x3A,0x20,0x25,0x64,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x4D,0x65
	.DB  0x73,0x69,0x63,0x3A,0x20,0x25,0x64,0x20
	.DB  0x3C,0x20,0x20,0x20,0x20,0x20,0x20,0x0
	.DB  0x4D,0x65,0x73,0x69,0x63,0x3A,0x20,0x25
	.DB  0x64,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x52,0x6F,0x6B,0x3A,0x20,0x32
	.DB  0x30,0x25,0x64,0x20,0x3C,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0x44,0x61,0x74,0x61,0x3A
	.DB  0x54,0x6F,0x3A,0x25,0x73,0x3A,0x54,0x72
	.DB  0x3A,0x25,0x73,0x3A,0x54,0x6F,0x6B,0x3A
	.DB  0x25,0x73,0x3A,0x77,0x3A,0x25,0x73,0x3A
	.DB  0x54,0x6F,0x6B,0x32,0x3A,0x25,0x73,0x3A
	.DB  0x48,0x75,0x6D,0x3A,0x25,0x73,0x0
_0x2040060:
	.DB  0x1
_0x2040000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x20A0003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x04
	.DW  _G
	.DW  _0x3*2

	.DW  0x04
	.DW  _konstADC
	.DW  _0x4*2

	.DW  0x04
	.DW  _Vref
	.DW  _0x5*2

	.DW  0x01
	.DW  _vyber
	.DW  _0x6*2

	.DW  0x01
	.DW  _konst_Rok_Max
	.DW  _0x7*2

	.DW  0x04
	.DW  _konst_A
	.DW  _0x8*2

	.DW  0x04
	.DW  _konst_B
	.DW  _0x9*2

	.DW  0x04
	.DW  _konst_C
	.DW  _0xA*2

	.DW  0x04
	.DW  _konst_D
	.DW  _0xB*2

	.DW  0x04
	.DW  _konstADCSHT
	.DW  _0xC*2

	.DW  0x04
	.DW  _konst
	.DW  _0xD*2

	.DW  0x04
	.DW  _frekcpu
	.DW  _0xE*2

	.DW  0x11
	.DW  _0x20
	.DW  _0x0*2

	.DW  0x11
	.DW  _0x20+17
	.DW  _0x0*2+17

	.DW  0x11
	.DW  _0x20+34
	.DW  _0x0*2+34

	.DW  0x11
	.DW  _0x20+51
	.DW  _0x0*2+115

	.DW  0x0F
	.DW  _0x20+68
	.DW  _0x0*2+324

	.DW  0x0F
	.DW  _0x20+83
	.DW  _0x0*2+324

	.DW  0x0F
	.DW  _0x20+98
	.DW  _0x0*2+324

	.DW  0x0F
	.DW  _0x20+113
	.DW  _0x0*2+443

	.DW  0x0F
	.DW  _0x20+128
	.DW  _0x0*2+443

	.DW  0x0F
	.DW  _0x20+143
	.DW  _0x0*2+443

	.DW  0x01
	.DW  __seed_G102
	.DW  _0x2040060*2

	.DW  0x02
	.DW  __base_y_G105
	.DW  _0x20A0003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

	OUT  RAMPZ,R24

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*****************************************************
;
;Projekt : Kompaktn snma operativn teploty
;Date    : 23.5.2012
;Author  : Ing. Jan Janeka
;
;Chip type               : ATmega128
;Program type            : Application
;AVR Core Clock frequency: 14,745600 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 1024
;*****************************************************/
;
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;
;// Standard Input/Output functions
;#include <stdio.h>
;#include <delay.h>
;#include <math.h>
;#include <stdlib.h>
;#include <string.h>
;
;// DS1307 Real Time Clock functions
;#include <ds1307.h>
;
;// Alphanumeric LCD Module functions
;#include <alcd.h>
;
;#asm
   .equ __i2c_port=0x12 ;PORTD
   .equ __sda_bit=1
   .equ __scl_bit=0
; 0000 0022 #endasm
;#include <i2c.h>
;
;#ifndef RXB8
;#define RXB8 1
;#endif
;
;#ifndef TXB8
;#define TXB8 0
;#endif
;
;#ifndef UPE
;#define UPE 2
;#endif
;
;#ifndef DOR
;#define DOR 3
;#endif
;
;#ifndef FE
;#define FE 4
;#endif
;
;#ifndef UDRE
;#define UDRE 5
;#endif
;
;#ifndef RXC
;#define RXC 7
;#endif
;
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<DOR)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;
;#define _BV	(bit)  (1 << (bit))
;#define bit_is_clear    (sfr,bit ) (!(_SFR_BYTE(sfr) & _BV(bit)))
;#define bit_is_set	(sfr,bit )	(_SFR_BYTE(sfr) & _BV(bit))
;
;
;#define setb(port,pin)    port |= 1<<pin    //nastav bit
;#define clrb(port,pin)    port &= ~(1<<pin) //nuluj bit
;#define negb(port,pin)    port ^= 1<<pin    //neguj bit
;
;#define KEY_PRESSED !(PINB&=0x80)
;#define KEY_OPEN (PINB&=0x80)
;
;#define KEY_PRESSED_PLUS !(PINB&=0x40)
;#define KEY_OPEN_PLUS (PINB&=0x40)
;
;#define KEY_PRESSED_OK !(PINB&=0x20)
;#define KEY_OPEN_OK (PINB&=0x20)
;
;#define KEY_PRESSED_MINUS !(PINB&=0x10)
;#define KEY_OPEN_MINUS (PINB&=0x10)
;
;unsigned int TMR1H;
;unsigned int TMR1L;
;unsigned int TMR2;
;unsigned int ADC_A1;
;unsigned int ADC_A2;
;
;unsigned int TSHTH;
;unsigned int TSHTL;
;unsigned int TSHT2;
;
;unsigned int HSHTH;
;unsigned int HSHTL;
;unsigned int HSHT2;
;
;//--------------------------------------------------------
;// Definice promnnch
;float counter_0=0, frekvence=0;
;char lcd_buffer[33];
;char lcd_buffer_Date[33];
;char lcd_buffer_Time[33];
;char lcd_buffer_Frek[33];
;char lcd_buffer_Toper[33];
;char lcd_buffer_Tokoli[33];
;char lcd_buffer_Trad[33];
;char lcd_buffer_Proudeni[33];
;char lcd_buffer_NapetiTokoli[33];
;char lcd_buffer_NapetiTrad[33];
;char lcd_buffer_ADC_A2[33];
;char lcd_buffer_ADC_A1[33];
;char lcd_buffer_SHTTep[33];
;char lcd_buffer_SHTHum[33];
;char lcd_buffer_ADC_SHT[33];
;char lcd_buffer_Hodiny[33];
;char lcd_buffer_Minuty[33];
;char lcd_buffer_Sekundy[33];
;char lcd_buffer_Datum[33];
;char lcd_buffer_Mesic[33];
;char lcd_buffer_Rok[33];
;char Frekstring[33];
;char Tradstring[33];
;char Tokolistring[33];
;char Proudenistring[33];
;char NapetiA2string[33];
;char NapetiA1string[33];
;char SHTTeplotastring[33];
;char SHTHumiditystring[33];
;char Tostring[33];
;char uart_buffer[63];
;int citac=0, nacteno;
;char znak;
;float napeti_A1, napeti_A2;
;float A , B , G=180.50;

	.DSEG
;unsigned char h, m, s;
;unsigned char date, month, year;
;char old;
;float Trad;
;float Tokoli;
;float To;
;float konstADC=32768;
;float Vref=2.0480;
;float proudeni;
;int vyber=10;
;float AP;
;unsigned int konst_Rok_Max = 50;
;unsigned int konst_Rok_Min = 0;
;float SHT_Teplota=0.0;
;unsigned int SHT_Teplota_ADC=0;
;float SHT_Humidity=0.0;
;unsigned int SHT_Humidity_ADC=0;
;float konst_A= -46.85;
;float konst_B=175.72;
;float konst_C= -6.0;
;float konst_D=125.0;
;float konstADCSHT=65536;
;unsigned int ToDAC;
;float konst=65535;
;float frekcpu=14745600;
;int k;
;
;// USART0 Receiver buffer
;#define RX_BUFFER_SIZE0 8
;char rx_buffer0[RX_BUFFER_SIZE0];
;
;#if RX_BUFFER_SIZE0 <= 256
;unsigned char rx_wr_index0,rx_rd_index0,rx_counter0;
;#else
;unsigned int rx_wr_index0,rx_rd_index0,rx_counter0;
;#endif
;
;// This flag is set on USART0 Receiver buffer overflow
;bit rx_buffer_overflow0;
;
;// USART0 Receiver interrupt service routine
;interrupt [USART0_RXC] void usart0_rx_isr(void)
; 0000 00BA {

	.CSEG
_usart0_rx_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00BB char status,data;
; 0000 00BC status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 00BD data=UDR0;
	IN   R16,12
; 0000 00BE if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0xF
; 0000 00BF    {
; 0000 00C0    rx_buffer0[rx_wr_index0++]=data;
	LDS  R30,_rx_wr_index0
	SUBI R30,-LOW(1)
	STS  _rx_wr_index0,R30
	CALL SUBOPT_0x0
	ST   Z,R16
; 0000 00C1 #if RX_BUFFER_SIZE0 == 256
; 0000 00C2    // special case for receiver buffer size=256
; 0000 00C3    if (++rx_counter0 == 0)
; 0000 00C4       {
; 0000 00C5 #else
; 0000 00C6    if (rx_wr_index0 == RX_BUFFER_SIZE0) rx_wr_index0=0;
	LDS  R26,_rx_wr_index0
	CPI  R26,LOW(0x8)
	BRNE _0x10
	LDI  R30,LOW(0)
	STS  _rx_wr_index0,R30
; 0000 00C7    if (++rx_counter0 == RX_BUFFER_SIZE0)
_0x10:
	LDS  R26,_rx_counter0
	SUBI R26,-LOW(1)
	STS  _rx_counter0,R26
	CPI  R26,LOW(0x8)
	BRNE _0x11
; 0000 00C8       {
; 0000 00C9       rx_counter0=0;
	LDI  R30,LOW(0)
	STS  _rx_counter0,R30
; 0000 00CA #endif
; 0000 00CB       rx_buffer_overflow0=1;
	SET
	BLD  R2,0
; 0000 00CC       }
; 0000 00CD    }
_0x11:
; 0000 00CE }
_0xF:
	LD   R16,Y+
	LD   R17,Y+
	RJMP _0x55
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Get a character from the USART0 Receiver buffer
;#define _ALTERNATE_GETCHAR_
;#pragma used+
;char getchar(void)
; 0000 00D5 {
_getchar:
; 0000 00D6 char data;
; 0000 00D7 while (rx_counter0==0);
	ST   -Y,R17
;	data -> R17
_0x12:
	LDS  R30,_rx_counter0
	CPI  R30,0
	BREQ _0x12
; 0000 00D8 data=rx_buffer0[rx_rd_index0++];
	LDS  R30,_rx_rd_index0
	SUBI R30,-LOW(1)
	STS  _rx_rd_index0,R30
	CALL SUBOPT_0x0
	LD   R17,Z
; 0000 00D9 #if RX_BUFFER_SIZE0 != 256
; 0000 00DA if (rx_rd_index0 == RX_BUFFER_SIZE0) rx_rd_index0=0;
	LDS  R26,_rx_rd_index0
	CPI  R26,LOW(0x8)
	BRNE _0x15
	LDI  R30,LOW(0)
	STS  _rx_rd_index0,R30
; 0000 00DB #endif
; 0000 00DC #asm("cli")
_0x15:
	cli
; 0000 00DD --rx_counter0;
	LDS  R30,_rx_counter0
	SUBI R30,LOW(1)
	STS  _rx_counter0,R30
; 0000 00DE #asm("sei")
	sei
; 0000 00DF return data;
	MOV  R30,R17
	LD   R17,Y+
	RET
; 0000 00E0 }
;#pragma used-
;#endif
;
;// USART0 Transmitter buffer
;#define TX_BUFFER_SIZE0 64
;char tx_buffer0[TX_BUFFER_SIZE0];
;
;#if TX_BUFFER_SIZE0 <= 256
;unsigned char tx_wr_index0,tx_rd_index0,tx_counter0;
;#else
;unsigned int tx_wr_index0,tx_rd_index0,tx_counter0;
;#endif
;
;// USART0 Transmitter interrupt service routine
;interrupt [USART0_TXC] void usart0_tx_isr(void)
; 0000 00F0 {
_usart0_tx_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00F1 if (tx_counter0)
	LDS  R30,_tx_counter0
	CPI  R30,0
	BREQ _0x16
; 0000 00F2    {
; 0000 00F3    --tx_counter0;
	SUBI R30,LOW(1)
	STS  _tx_counter0,R30
; 0000 00F4    UDR0=tx_buffer0[tx_rd_index0++];
	LDS  R30,_tx_rd_index0
	SUBI R30,-LOW(1)
	STS  _tx_rd_index0,R30
	CALL SUBOPT_0x1
	LD   R30,Z
	OUT  0xC,R30
; 0000 00F5 #if TX_BUFFER_SIZE0 != 256
; 0000 00F6    if (tx_rd_index0 == TX_BUFFER_SIZE0) tx_rd_index0=0;
	LDS  R26,_tx_rd_index0
	CPI  R26,LOW(0x40)
	BRNE _0x17
	LDI  R30,LOW(0)
	STS  _tx_rd_index0,R30
; 0000 00F7 #endif
; 0000 00F8    }
_0x17:
; 0000 00F9 }
_0x16:
_0x55:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Write a character to the USART0 Transmitter buffer
;#define _ALTERNATE_PUTCHAR_
;#pragma used+
;void putchar(char c)
; 0000 0100 {
_putchar:
; 0000 0101 while (tx_counter0 == TX_BUFFER_SIZE0);
;	c -> Y+0
_0x18:
	LDS  R26,_tx_counter0
	CPI  R26,LOW(0x40)
	BREQ _0x18
; 0000 0102 #asm("cli")
	cli
; 0000 0103 if (tx_counter0 || ((UCSR0A & DATA_REGISTER_EMPTY)==0))
	LDS  R30,_tx_counter0
	CPI  R30,0
	BRNE _0x1C
	SBIC 0xB,5
	RJMP _0x1B
_0x1C:
; 0000 0104    {
; 0000 0105    tx_buffer0[tx_wr_index0++]=c;
	LDS  R30,_tx_wr_index0
	SUBI R30,-LOW(1)
	STS  _tx_wr_index0,R30
	CALL SUBOPT_0x1
	LD   R26,Y
	STD  Z+0,R26
; 0000 0106 #if TX_BUFFER_SIZE0 != 256
; 0000 0107    if (tx_wr_index0 == TX_BUFFER_SIZE0) tx_wr_index0=0;
	LDS  R26,_tx_wr_index0
	CPI  R26,LOW(0x40)
	BRNE _0x1E
	LDI  R30,LOW(0)
	STS  _tx_wr_index0,R30
; 0000 0108 #endif
; 0000 0109    ++tx_counter0;
_0x1E:
	LDS  R30,_tx_counter0
	SUBI R30,-LOW(1)
	STS  _tx_counter0,R30
; 0000 010A    }
; 0000 010B else
	RJMP _0x1F
_0x1B:
; 0000 010C    UDR0=c;
	LD   R30,Y
	OUT  0xC,R30
; 0000 010D #asm("sei")
_0x1F:
	sei
; 0000 010E }
	RJMP _0x210000B
;#pragma used-
;#endif
;
;// Timer1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 0114 {
_timer1_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0115 citac++ ;
	LDI  R26,LOW(_citac)
	LDI  R27,HIGH(_citac)
	CALL SUBOPT_0x2
; 0000 0116 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;// Timer2 output compare interrupt service routine
;interrupt [TIM2_COMP] void timer2_comp_isr(void)
; 0000 011A {
_timer2_comp_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 011B counter_0 = TCNT1;
	IN   R30,0x2C
	IN   R31,0x2C+1
	LDI  R26,LOW(_counter_0)
	LDI  R27,HIGH(_counter_0)
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __PUTDP1
; 0000 011C nacteno=citac;
	LDS  R30,_citac
	LDS  R31,_citac+1
	STS  _nacteno,R30
	STS  _nacteno+1,R31
; 0000 011D citac=0;
	LDI  R30,LOW(0)
	STS  _citac,R30
	STS  _citac+1,R30
; 0000 011E TCNT1=0x0000;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
; 0000 011F TCNT2=0x00;
	OUT  0x24,R30
; 0000 0120 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;void ADS110A1_Write(unsigned char outdat)
; 0000 0123 {
_ADS110A1_Write:
; 0000 0124     i2c_start();
;	outdat -> Y+0
	CALL _i2c_start
; 0000 0125     i2c_write(0x92);
	LDI  R30,LOW(146)
	RJMP _0x210000A
; 0000 0126     i2c_write(outdat);
; 0000 0127     i2c_stop();
; 0000 0128 }
;
;void ADS110A1_Read(void)
; 0000 012B {
_ADS110A1_Read:
; 0000 012C     i2c_start();
	CALL _i2c_start
; 0000 012D     i2c_write(0x93);
	LDI  R30,LOW(147)
	CALL SUBOPT_0x3
; 0000 012E     TMR1H=i2c_read(1);
; 0000 012F     TMR1L=i2c_read(1);
; 0000 0130     TMR2=i2c_read(0);
; 0000 0131     i2c_stop();
	RJMP _0x2100009
; 0000 0132 }
;
;
;void ADS110A2_Write(unsigned char outdat)
; 0000 0136 {
_ADS110A2_Write:
; 0000 0137     i2c_start();
;	outdat -> Y+0
	CALL _i2c_start
; 0000 0138     i2c_write(0x94);
	LDI  R30,LOW(148)
_0x210000A:
	ST   -Y,R30
	CALL SUBOPT_0x4
; 0000 0139     i2c_write(outdat);
	CALL SUBOPT_0x5
; 0000 013A     i2c_stop();
; 0000 013B }
_0x210000B:
	ADIW R28,1
	RET
;
;void ADS110A2_Read(void)
; 0000 013E {
_ADS110A2_Read:
; 0000 013F     i2c_start();
	CALL _i2c_start
; 0000 0140     i2c_write(0x95);
	LDI  R30,LOW(149)
	CALL SUBOPT_0x3
; 0000 0141     TMR1H=i2c_read(1);
; 0000 0142     TMR1L=i2c_read(1);
; 0000 0143     TMR2=i2c_read(0);
; 0000 0144     i2c_stop();
	RJMP _0x2100009
; 0000 0145 }
;
;
;void SHT25_Temp(void)
; 0000 0149 {
_SHT25_Temp:
; 0000 014A     i2c_start();
	CALL SUBOPT_0x6
; 0000 014B     i2c_write(0x80);
; 0000 014C     i2c_write(0xE3);
	LDI  R30,LOW(227)
	CALL SUBOPT_0x7
; 0000 014D     i2c_start();
; 0000 014E     i2c_write(0x81);
; 0000 014F     TSHTH=i2c_read(1);
	STS  _TSHTH,R30
	STS  _TSHTH+1,R31
; 0000 0150     TSHTL=i2c_read(1);
	CALL SUBOPT_0x8
	STS  _TSHTL,R30
	STS  _TSHTL+1,R31
; 0000 0151     TSHT2=i2c_read(0);
	CALL SUBOPT_0x9
	STS  _TSHT2,R30
	STS  _TSHT2+1,R31
; 0000 0152     i2c_stop();
	RJMP _0x2100009
; 0000 0153 }
;
;
;void SHT25_Hum(void)
; 0000 0157 {
_SHT25_Hum:
; 0000 0158     i2c_start();
	CALL SUBOPT_0x6
; 0000 0159     i2c_write(0x80);
; 0000 015A     i2c_write(0xE5);
	LDI  R30,LOW(229)
	CALL SUBOPT_0x7
; 0000 015B     i2c_start();
; 0000 015C     i2c_write(0x81);
; 0000 015D     HSHTH=i2c_read(1);
	STS  _HSHTH,R30
	STS  _HSHTH+1,R31
; 0000 015E     HSHTL=i2c_read(1);
	CALL SUBOPT_0x8
	STS  _HSHTL,R30
	STS  _HSHTL+1,R31
; 0000 015F     HSHT2=i2c_read(0);
	CALL SUBOPT_0x9
	STS  _HSHT2,R30
	STS  _HSHT2+1,R31
; 0000 0160     i2c_stop();
_0x2100009:
	CALL _i2c_stop
; 0000 0161 }
	RET
;
;void DAC(unsigned int data)
; 0000 0164 {
_DAC:
; 0000 0165     char lVout = data;
; 0000 0166 	char hVout = (data>>8) & 0x0F;
; 0000 0167     i2c_start();
	ST   -Y,R17
	ST   -Y,R16
;	data -> Y+2
;	lVout -> R17
;	hVout -> R16
	LDD  R17,Y+2
	LDD  R30,Y+3
	ANDI R31,HIGH(0x0)
	ANDI R30,LOW(0xF)
	MOV  R16,R30
	CALL _i2c_start
; 0000 0168     i2c_write(0xC0);
	LDI  R30,LOW(192)
	ST   -Y,R30
	CALL SUBOPT_0xA
; 0000 0169     i2c_write(hVout);
; 0000 016A     i2c_write(lVout);
	CALL SUBOPT_0xA
; 0000 016B     i2c_write(hVout);
; 0000 016C     i2c_write(lVout);
	CALL SUBOPT_0x5
; 0000 016D     i2c_stop();
; 0000 016E }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
;
;void main(void)
; 0000 0171 {
_main:
; 0000 0172 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	CALL SUBOPT_0xB
; 0000 0173 
; 0000 0174 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0175 DDRA=0x00;
	OUT  0x1A,R30
; 0000 0176 PORTB=0x00;
	OUT  0x18,R30
; 0000 0177 DDRB=0x00;
	OUT  0x17,R30
; 0000 0178 PORTC=0x00;
	OUT  0x15,R30
; 0000 0179 DDRC=0x00;
	OUT  0x14,R30
; 0000 017A PORTD=0x00;
	OUT  0x12,R30
; 0000 017B DDRD=0x00;
	OUT  0x11,R30
; 0000 017C PORTE=0x00;
	OUT  0x3,R30
; 0000 017D DDRE=0x00;
	OUT  0x2,R30
; 0000 017E PORTF=0x00;
	STS  98,R30
; 0000 017F DDRF=0x00;
	STS  97,R30
; 0000 0180 PORTG=0x00;
	STS  101,R30
; 0000 0181 DDRG=0x00;
	STS  100,R30
; 0000 0182 
; 0000 0183 // Timer/Counter 0 initialization
; 0000 0184 // Clock source: System Clock
; 0000 0185 // Clock value: Timer 0 Stopped
; 0000 0186 // Mode: Normal top=0xFF
; 0000 0187 // OC0 output: Disconnected
; 0000 0188 ASSR=0x00;
	OUT  0x30,R30
; 0000 0189 TCCR0=0x00;
	OUT  0x33,R30
; 0000 018A TCNT0=0x00;
	OUT  0x32,R30
; 0000 018B OCR0=0x00;
	OUT  0x31,R30
; 0000 018C 
; 0000 018D // Timer/Counter 1 initialization
; 0000 018E // Clock source: System Clock
; 0000 018F // Clock value: 16000,000 kHz
; 0000 0190 // Mode: Normal top=0xFFFF
; 0000 0191 // OC1A output: Discon.
; 0000 0192 // OC1B output: Discon.
; 0000 0193 // OC1C output: Discon.
; 0000 0194 // Noise Canceler: Off
; 0000 0195 // Input Capture on Falling Edge
; 0000 0196 // Timer1 Overflow Interrupt: On
; 0000 0197 // Input Capture Interrupt: Off
; 0000 0198 // Compare A Match Interrupt: Off
; 0000 0199 // Compare B Match Interrupt: Off
; 0000 019A // Compare C Match Interrupt: Off
; 0000 019B TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 019C TCCR1B=0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
; 0000 019D TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 019E TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 019F ICR1H=0x00;
	OUT  0x27,R30
; 0000 01A0 ICR1L=0x00;
	OUT  0x26,R30
; 0000 01A1 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 01A2 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 01A3 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 01A4 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 01A5 OCR1CH=0x00;
	STS  121,R30
; 0000 01A6 OCR1CL=0x00;
	STS  120,R30
; 0000 01A7 
; 0000 01A8 // Timer/Counter 2 initialization
; 0000 01A9 // Clock source: T2 pin Rising Edge
; 0000 01AA // Clock value: Timer2 Stopped
; 0000 01AB // Mode: CTC top=OCR2
; 0000 01AC // OC2 output: Disconnected
; 0000 01AD TCCR2=0x0F;
	LDI  R30,LOW(15)
	OUT  0x25,R30
; 0000 01AE TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 01AF OCR2=0x01;
	LDI  R30,LOW(1)
	OUT  0x23,R30
; 0000 01B0 
; 0000 01B1 // Timer/Counter 3 initialization
; 0000 01B2 // Clock source: System Clock
; 0000 01B3 // Clock value: Timer3 Stopped
; 0000 01B4 // Mode: Normal top=0xFFFF
; 0000 01B5 // OC3A output: Discon.
; 0000 01B6 // OC3B output: Discon.
; 0000 01B7 // OC3C output: Discon.
; 0000 01B8 // Noise Canceler: Off
; 0000 01B9 // Input Capture on Falling Edge
; 0000 01BA // Timer3 Overflow Interrupt: Off
; 0000 01BB // Input Capture Interrupt: Off
; 0000 01BC // Compare A Match Interrupt: Off
; 0000 01BD // Compare B Match Interrupt: Off
; 0000 01BE // Compare C Match Interrupt: Off
; 0000 01BF TCCR3A=0x00;
	LDI  R30,LOW(0)
	STS  139,R30
; 0000 01C0 TCCR3B=0x00;
	STS  138,R30
; 0000 01C1 TCNT3H=0x00;
	STS  137,R30
; 0000 01C2 TCNT3L=0x00;
	STS  136,R30
; 0000 01C3 ICR3H=0x00;
	STS  129,R30
; 0000 01C4 ICR3L=0x00;
	STS  128,R30
; 0000 01C5 OCR3AH=0x00;
	STS  135,R30
; 0000 01C6 OCR3AL=0x00;
	STS  134,R30
; 0000 01C7 OCR3BH=0x00;
	STS  133,R30
; 0000 01C8 OCR3BL=0x00;
	STS  132,R30
; 0000 01C9 OCR3CH=0x00;
	STS  131,R30
; 0000 01CA OCR3CL=0x00;
	STS  130,R30
; 0000 01CB 
; 0000 01CC // External Interrupt(s) initialization
; 0000 01CD // INT0: Off
; 0000 01CE // INT1: Off
; 0000 01CF // INT2: Off
; 0000 01D0 // INT3: Off
; 0000 01D1 // INT4: Off
; 0000 01D2 // INT5: Off
; 0000 01D3 // INT6: Off
; 0000 01D4 // INT7: Off
; 0000 01D5 EICRA=0x00;
	STS  106,R30
; 0000 01D6 EICRB=0x00;
	OUT  0x3A,R30
; 0000 01D7 EIMSK=0x00;
	OUT  0x39,R30
; 0000 01D8 
; 0000 01D9 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01DA TIMSK=0x84;
	LDI  R30,LOW(132)
	OUT  0x37,R30
; 0000 01DB 
; 0000 01DC ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
; 0000 01DD 
; 0000 01DE // USART0 initialization
; 0000 01DF // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 01E0 // USART0 Receiver: On
; 0000 01E1 // USART0 Transmitter: On
; 0000 01E2 // USART0 Mode: Asynchronous
; 0000 01E3 // USART0 Baud Rate: 1200
; 0000 01E4 UCSR0A=0x00;
	OUT  0xB,R30
; 0000 01E5 UCSR0B=0xD8;
	LDI  R30,LOW(216)
	OUT  0xA,R30
; 0000 01E6 UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
; 0000 01E7 UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
; 0000 01E8 UBRR0L=0x07;
	LDI  R30,LOW(7)
	OUT  0x9,R30
; 0000 01E9 
; 0000 01EA // USART1 initialization
; 0000 01EB // USART1 disabled
; 0000 01EC UCSR1B=0x00;
	LDI  R30,LOW(0)
	STS  154,R30
; 0000 01ED 
; 0000 01EE // Analog Comparator initialization
; 0000 01EF // Analog Comparator: Off
; 0000 01F0 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01F1 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 01F2 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 01F3 
; 0000 01F4 // ADC initialization
; 0000 01F5 // ADC disabled
; 0000 01F6 ADCSRA=0x00;
	OUT  0x6,R30
; 0000 01F7 
; 0000 01F8 // SPI initialization
; 0000 01F9 // SPI disabled
; 0000 01FA SPCR=0x00;
	OUT  0xD,R30
; 0000 01FB 
; 0000 01FC // TWI initialization
; 0000 01FD // TWI disabled
; 0000 01FE TWCR=0x00;
	STS  116,R30
; 0000 01FF 
; 0000 0200 // I2C Bus initialization
; 0000 0201 i2c_init();
	CALL _i2c_init
; 0000 0202 
; 0000 0203 // DS1307 Real Time Clock initialization
; 0000 0204 // Square wave output on pin SQW/OUT: Off
; 0000 0205 // SQW/OUT pin state: 0
; 0000 0206 rtc_init(0,0,0);
	CALL SUBOPT_0xC
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _rtc_init
; 0000 0207 
; 0000 0208 //rtc_set_time(17,23,0);
; 0000 0209 //rtc_set_date(24,06,12);
; 0000 020A 
; 0000 020B // Alphanumeric LCD initialization
; 0000 020C // Connections specified in the
; 0000 020D // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 020E // RS - PORTC Bit 0
; 0000 020F // RD - PORTC Bit 1
; 0000 0210 // EN - PORTC Bit 2
; 0000 0211 // D4 - PORTC Bit 4
; 0000 0212 // D5 - PORTC Bit 6
; 0000 0213 // D6 - PORTC Bit 7
; 0000 0214 // D7 - PORTC Bit 5
; 0000 0215 // Characters/line: 16
; 0000 0216 
; 0000 0217 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
; 0000 0218 
; 0000 0219 // Global enable interrupts
; 0000 021A #asm("sei")
	sei
; 0000 021B 
; 0000 021C  lcd_gotoxy(0,0);
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 021D  lcd_puts("Kompaktni snimac");
	__POINTW1MN _0x20,0
	CALL SUBOPT_0xD
; 0000 021E  lcd_gotoxy(0,1);
	CALL SUBOPT_0xE
; 0000 021F  lcd_puts("---Operativni---");
	__POINTW1MN _0x20,17
	CALL SUBOPT_0xD
; 0000 0220  lcd_gotoxy(0,2);
	CALL SUBOPT_0xF
; 0000 0221  lcd_puts("----teploty-----");
	__POINTW1MN _0x20,34
	CALL SUBOPT_0x10
; 0000 0222  for(k=20;k>0;k--)
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	STS  _k,R30
	STS  _k+1,R31
_0x22:
	LDS  R26,_k
	LDS  R27,_k+1
	CALL __CPW02
	BRGE _0x23
; 0000 0223  {
; 0000 0224  sprintf(lcd_buffer," Cekejte... %d   ",k);
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,51
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_k
	LDS  R31,_k+1
	CALL __CWD1
	CALL SUBOPT_0x11
; 0000 0225  lcd_gotoxy(0,3);
; 0000 0226  lcd_puts(lcd_buffer);
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	CALL SUBOPT_0x10
; 0000 0227   delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0xB
; 0000 0228  }
	LDI  R26,LOW(_k)
	LDI  R27,HIGH(_k)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x22
_0x23:
; 0000 0229 
; 0000 022A   lcd_clear();
	CALL _lcd_clear
; 0000 022B 
; 0000 022C   ADS110A1_Write(0x8C);
	LDI  R30,LOW(140)
	ST   -Y,R30
	RCALL _ADS110A1_Write
; 0000 022D   delay_ms(5);
	CALL SUBOPT_0x12
; 0000 022E   ADS110A2_Write(0x8C);
	LDI  R30,LOW(140)
	ST   -Y,R30
	RCALL _ADS110A2_Write
; 0000 022F   delay_ms(5);
	CALL SUBOPT_0x12
; 0000 0230 
; 0000 0231 
; 0000 0232 while (1)
_0x24:
; 0000 0233       {
; 0000 0234 
; 0000 0235       float pom_frek=0, pom_ADC_A1=0 ;
; 0000 0236       int i=0, j=0;
; 0000 0237 
; 0000 0238         if  (KEY_PRESSED | KEY_PRESSED_OK)
	SBIW R28,12
	LDI  R24,12
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x27*2)
	LDI  R31,HIGH(_0x27*2)
	CALL __INITLOCB
;	pom_frek -> Y+8
;	pom_ADC_A1 -> Y+4
;	i -> Y+2
;	j -> Y+0
	IN   R30,0x16
	ANDI R30,LOW(0x80)
	OUT  0x16,R30
	CALL __LNEGB1
	MOV  R26,R30
	IN   R30,0x16
	ANDI R30,LOW(0x20)
	OUT  0x16,R30
	CALL __LNEGB1
	OR   R30,R26
	BREQ _0x28
; 0000 0239        {
; 0000 023A       	vyber=vyber+1;
	LDS  R30,_vyber
	LDS  R31,_vyber+1
	ADIW R30,1
	STS  _vyber,R30
	STS  _vyber+1,R31
; 0000 023B        	 if (vyber>10)
	CALL SUBOPT_0x13
	SBIW R26,11
	BRLT _0x29
; 0000 023C          {
; 0000 023D          vyber=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _vyber,R30
	STS  _vyber+1,R31
; 0000 023E          delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0xB
; 0000 023F          }
; 0000 0240        }
_0x29:
; 0000 0241 
; 0000 0242          if (counter_0 || nacteno > 0)
_0x28:
	LDS  R30,_counter_0
	LDS  R31,_counter_0+1
	LDS  R22,_counter_0+2
	LDS  R23,_counter_0+3
	CALL __CPD10
	BRNE _0x2B
	LDS  R26,_nacteno
	LDS  R27,_nacteno+1
	CALL __CPW02
	BRLT _0x2B
	RJMP _0x2A
_0x2B:
; 0000 0243          {
; 0000 0244          for(i=0;i<20;i++)
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x2E:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,20
	BRLT PC+3
	JMP _0x2F
; 0000 0245              if(i<19)
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,19
	BRLT PC+3
	JMP _0x30
; 0000 0246                {
; 0000 0247                 if (frekvence>150 & frekvence<820)   // pridano overit!!!
	CALL SUBOPT_0x14
	__GETD1N 0x43160000
	CALL __GTF12
	MOV  R0,R30
	CALL SUBOPT_0x14
	__GETD1N 0x444D0000
	CALL __LTF12
	AND  R30,R0
	BREQ _0x31
; 0000 0248                 {
; 0000 0249                 frekvence=(frekcpu/(counter_0+(nacteno*konst)))*2;
	LDS  R30,_konst
	LDS  R31,_konst+1
	LDS  R22,_konst+2
	LDS  R23,_konst+3
	LDS  R26,_nacteno
	LDS  R27,_nacteno+1
	CALL __CWD2
	CALL __CDF2
	CALL __MULF12
	LDS  R26,_counter_0
	LDS  R27,_counter_0+1
	LDS  R24,_counter_0+2
	LDS  R25,_counter_0+3
	CALL __ADDF12
	LDS  R26,_frekcpu
	LDS  R27,_frekcpu+1
	LDS  R24,_frekcpu+2
	LDS  R25,_frekcpu+3
	CALL __DIVF21
	__GETD2N 0x40000000
	CALL __MULF12
	CALL SUBOPT_0x15
; 0000 024A                 pom_frek=frekvence+pom_frek ;
	__GETD1S 8
	CALL SUBOPT_0x14
	CALL __ADDF12
	__PUTD1S 8
; 0000 024B                 delay_ms(5);
	CALL SUBOPT_0x12
; 0000 024C                 }
; 0000 024D                 }
_0x31:
; 0000 024E                 if(i>18)
_0x30:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x2E
_0x2F:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,19
	BRLT _0x32
; 0000 024F              {
; 0000 0250                frekvence=(pom_frek/19);
	__GETD2S 8
	__GETD1N 0x41980000
	CALL __DIVF21
	CALL SUBOPT_0x15
; 0000 0251              }
; 0000 0252 
; 0000 0253               ftoa(frekvence,0,Frekstring);
_0x32:
	CALL SUBOPT_0x16
	CALL __PUTPARD1
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(_Frekstring)
	LDI  R31,HIGH(_Frekstring)
	CALL SUBOPT_0x17
; 0000 0254 
; 0000 0255            if (frekvence<180)
	CALL SUBOPT_0x18
	CALL __CMPF12
	BRSH _0x33
; 0000 0256            {
; 0000 0257             proudeni=0.00;
	LDI  R30,LOW(0)
	STS  _proudeni,R30
	STS  _proudeni+1,R30
	STS  _proudeni+2,R30
	STS  _proudeni+3,R30
; 0000 0258            }
; 0000 0259 
; 0000 025A            if (frekvence>800)
_0x33:
	CALL SUBOPT_0x19
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x34
; 0000 025B            {
; 0000 025C             proudeni=6.54;
	__GETD1N 0x40D147AE
	CALL SUBOPT_0x1A
; 0000 025D            }
; 0000 025E 
; 0000 025F            if (frekvence>180 & frekvence<800)
_0x34:
	CALL SUBOPT_0x18
	CALL __GTF12
	MOV  R0,R30
	CALL SUBOPT_0x19
	CALL __LTF12
	AND  R30,R0
	BRNE PC+3
	JMP _0x35
; 0000 0260            {
; 0000 0261            proudeni=3.80242-0.0706151*frekvence + 0.000503032*frekvence*frekvence-0.00000177436*frekvence*frekvence*frekvence + 0.00000000337857*frekvence*frekvence*frekvence*frekvence-0.00000000000326827*frekvence*frekvence*frekvence*frekvence*frekvence + 0.00000000000000126988*frekvence*frekvence*frekvence*frekvence*frekvence*frekvence;
	CALL SUBOPT_0x16
	__GETD2N 0x3D909EA6
	CALL __MULF12
	__GETD2N 0x40735AD9
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	__GETD2N 0x3A03DDE8
	CALL SUBOPT_0x1C
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	__GETD2N 0x35EE268C
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x14
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	__GETD2N 0x31682C6F
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	__GETD2N 0x2C65FBEB
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x14
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	__GETD2N 0x26B7024D
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	CALL SUBOPT_0x1A
; 0000 0262            }
; 0000 0263            ftoa(proudeni,2,Proudenistring);
_0x35:
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1F
	LDI  R30,LOW(_Proudenistring)
	LDI  R31,HIGH(_Proudenistring)
	CALL SUBOPT_0x17
; 0000 0264          }
; 0000 0265 
; 0000 0266        // Reln as z DS1307
; 0000 0267        rtc_get_time(&h, &m, &s);
_0x2A:
	LDI  R30,LOW(_h)
	LDI  R31,HIGH(_h)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_m)
	LDI  R31,HIGH(_m)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_s)
	LDI  R31,HIGH(_s)
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_time
; 0000 0268        rtc_get_date(&date, &month, &year);
	LDI  R30,LOW(_date)
	LDI  R31,HIGH(_date)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_month)
	LDI  R31,HIGH(_month)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_year)
	LDI  R31,HIGH(_year)
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_date
; 0000 0269 
; 0000 026A        // cteni ADS1110 A1 - radian teplota
; 0000 026B 
; 0000 026C          for(j=0;j<10;j++)
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
_0x37:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,10
	BRGE _0x38
; 0000 026D              if(j<9)
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,9
	BRGE _0x39
; 0000 026E                {
; 0000 026F                 ADS110A1_Read();
	RCALL _ADS110A1_Read
; 0000 0270                 ADC_A1=(TMR1H*256)+TMR1L;
	MOV  R31,R4
	LDI  R30,LOW(0)
	ADD  R30,R6
	ADC  R31,R7
	MOVW R10,R30
; 0000 0271                 pom_ADC_A1=ADC_A1+pom_ADC_A1;
	__GETD1S 4
	MOVW R26,R10
	CALL SUBOPT_0x20
	CALL __ADDF12
	__PUTD1S 4
; 0000 0272                 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0xB
; 0000 0273                 }
; 0000 0274                 if(j>8)
_0x39:
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0x37
_0x38:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,9
	BRLT _0x3A
; 0000 0275              {
; 0000 0276                ADC_A1=(pom_ADC_A1/9);
	__GETD2S 4
	__GETD1N 0x41100000
	CALL __DIVF21
	CALL __CFD1U
	MOVW R10,R30
; 0000 0277              }
; 0000 0278 
; 0000 0279         napeti_A1=(ADC_A1/konstADC)*Vref;
_0x3A:
	CALL SUBOPT_0x21
	MOVW R26,R10
	CALL SUBOPT_0x22
	CALL SUBOPT_0x23
; 0000 027A         napeti_A1=napeti_A1*2.5;
	CALL SUBOPT_0x24
	CALL SUBOPT_0x25
	CALL SUBOPT_0x23
; 0000 027B 
; 0000 027C         //Radian teplota pro snma 60C
; 0000 027D         // Trad= -0.002603*napeti_A1*napeti_A1*napeti_A1*napeti_A1*napeti_A1*napeti_A1 + 0.04802*napeti_A1*napeti_A1*napeti_A1*napeti_A1*napeti_A1 - 0.38431*napeti_A1*napeti_A1*napeti_A1*napeti_A1 + 1.8498*napeti_A1*napeti_A1*napeti_A1 - 6.835*napeti_A1*napeti_A1 + 32.71*napeti_A1 - 26.75;
; 0000 027E 
; 0000 027F         //Radian snma pro 180C
; 0000 0280          Trad= -0.477130*napeti_A1*napeti_A1*napeti_A1*napeti_A1*napeti_A1*napeti_A1 + 8.48270*napeti_A1*napeti_A1*napeti_A1*napeti_A1*napeti_A1 - 61.41728*napeti_A1*napeti_A1*napeti_A1*napeti_A1 + 232.9302*napeti_A1*napeti_A1*napeti_A1 - 496.803*napeti_A1*napeti_A1 + 624.76*napeti_A1 - 306.35;
	CALL SUBOPT_0x26
	__GETD2N 0xBEF44A62
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x26
	__GETD2N 0x4107B924
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x26
	__GETD2N 0x4275AB4B
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x26
	__GETD2N 0x4368EE22
	CALL SUBOPT_0x27
	CALL SUBOPT_0x27
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x26
	__GETD2N 0x43F866C9
	CALL SUBOPT_0x27
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x26
	__GETD2N 0x441C30A4
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x28
	__GETD1N 0x43992CCD
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x29
; 0000 0281          Trad=Trad-2.0;
	CALL SUBOPT_0x2A
	__GETD2N 0x40000000
	CALL __SUBF12
	CALL SUBOPT_0x29
; 0000 0282 
; 0000 0283          ftoa(napeti_A1,2,NapetiA1string);
	CALL SUBOPT_0x26
	CALL SUBOPT_0x1F
	LDI  R30,LOW(_NapetiA1string)
	LDI  R31,HIGH(_NapetiA1string)
	CALL SUBOPT_0x17
; 0000 0284          ftoa(Trad,1,Tradstring);
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2B
	LDI  R30,LOW(_Tradstring)
	LDI  R31,HIGH(_Tradstring)
	CALL SUBOPT_0x17
; 0000 0285 
; 0000 0286 
; 0000 0287          // cteni ADS1110 A2 - okoln teplota
; 0000 0288 
; 0000 0289         ADS110A2_Read();
	RCALL _ADS110A2_Read
; 0000 028A         ADC_A2=(TMR1H*256)+TMR1L;
	MOV  R31,R4
	LDI  R30,LOW(0)
	ADD  R30,R6
	ADC  R31,R7
	MOVW R12,R30
; 0000 028B 
; 0000 028C         napeti_A2=(ADC_A2/konstADC)*Vref;
	CALL SUBOPT_0x21
	MOVW R26,R12
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2C
; 0000 028D         napeti_A2=napeti_A2*2.5;
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x25
	CALL SUBOPT_0x2C
; 0000 028E         A = -1.523563 * napeti_A2 * napeti_A2 * napeti_A2 * napeti_A2 * napeti_A2 * napeti_A2 + 20.52003 * napeti_A2 * napeti_A2 * napeti_A2 * napeti_A2 * napeti_A2 - 112.09588 * napeti_A2 * napeti_A2 * napeti_A2 * napeti_A2;
	CALL SUBOPT_0x2E
	__GETD2N 0xBFC3041D
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x2E
	__GETD2N 0x41A42905
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x2E
	__GETD2N 0x42E03117
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	STS  _A,R30
	STS  _A+1,R31
	STS  _A+2,R22
	STS  _A+3,R23
; 0000 028F         B = 319.2295 * napeti_A2 * napeti_A2 * napeti_A2 - 508.327 * napeti_A2 * napeti_A2 + 475.52 * napeti_A2 - G;
	CALL SUBOPT_0x2E
	__GETD2N 0x439F9D60
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x2E
	__GETD2N 0x43FE29DB
	CALL SUBOPT_0x2F
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x2E
	__GETD2N 0x43EDC28F
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	CALL __SUBF12
	STS  _B,R30
	STS  _B+1,R31
	STS  _B+2,R22
	STS  _B+3,R23
; 0000 0290 
; 0000 0291         Tokoli = A + B -1.4;
	LDS  R26,_A
	LDS  R27,_A+1
	LDS  R24,_A+2
	LDS  R25,_A+3
	CALL SUBOPT_0x28
	__GETD1N 0x3FB33333
	CALL SUBOPT_0x1B
	STS  _Tokoli,R30
	STS  _Tokoli+1,R31
	STS  _Tokoli+2,R22
	STS  _Tokoli+3,R23
; 0000 0292 
; 0000 0293         ftoa(napeti_A2,2,NapetiA2string);
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x1F
	LDI  R30,LOW(_NapetiA2string)
	LDI  R31,HIGH(_NapetiA2string)
	CALL SUBOPT_0x17
; 0000 0294         ftoa(Tokoli,1,Tokolistring);
	CALL SUBOPT_0x30
	CALL SUBOPT_0x2B
	LDI  R30,LOW(_Tokolistring)
	LDI  R31,HIGH(_Tokolistring)
	CALL SUBOPT_0x17
; 0000 0295 
; 0000 0296       // Vpoet operativn teploty
; 0000 0297        // To = A . ta + (1 - A) tr
; 0000 0298 
; 0000 0299        AP=0.34584+1.65437*proudeni-3.32182*proudeni*proudeni+3.70809*proudeni*proudeni*proudeni-2.34848*proudeni*proudeni*proudeni*proudeni+0.870849*proudeni*proudeni*proudeni*proudeni*proudeni-0.187175*proudeni*proudeni*proudeni*proudeni*proudeni*proudeni+0.0215784*proudeni*proudeni*proudeni*proudeni*proudeni*proudeni*proudeni-0.00103157*proudeni*proudeni*proudeni*proudeni*proudeni*proudeni*proudeni*proudeni;;
	CALL SUBOPT_0x1E
	__GETD2N 0x3FD3C265
	CALL __MULF12
	__GETD2N 0x3EB111F1
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1E
	__GETD2N 0x405498B3
	CALL SUBOPT_0x31
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1E
	__GETD2N 0x406D5159
	CALL SUBOPT_0x31
	CALL SUBOPT_0x32
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1E
	__GETD2N 0x40164D7F
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1E
	__GETD2N 0x3F5EEFF6
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	CALL SUBOPT_0x32
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1E
	__GETD2N 0x3E3FAACE
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	CALL SUBOPT_0x33
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1E
	__GETD2N 0x3CB0C52F
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	CALL SUBOPT_0x33
	CALL SUBOPT_0x32
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1E
	__GETD2N 0x3A8735BF
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	CALL SUBOPT_0x33
	CALL SUBOPT_0x33
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1B
	STS  _AP,R30
	STS  _AP+1,R31
	STS  _AP+2,R22
	STS  _AP+3,R23
; 0000 029A        To=AP*Tokoli+(1.0-AP)*Trad;
	CALL SUBOPT_0x30
	CALL SUBOPT_0x34
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x34
	__GETD1N 0x3F800000
	CALL __SUBF12
	LDS  R26,_Trad
	LDS  R27,_Trad+1
	LDS  R24,_Trad+2
	LDS  R25,_Trad+3
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	STS  _To,R30
	STS  _To+1,R31
	STS  _To+2,R22
	STS  _To+3,R23
; 0000 029B 
; 0000 029C        ftoa(To,1,Tostring);
	CALL SUBOPT_0x35
	CALL SUBOPT_0x2B
	LDI  R30,LOW(_Tostring)
	LDI  R31,HIGH(_Tostring)
	CALL SUBOPT_0x17
; 0000 029D        SHT25_Temp();
	RCALL _SHT25_Temp
; 0000 029E        SHT_Teplota_ADC =(TSHTH*256)+TSHTL;
	LDS  R31,_TSHTH
	LDI  R30,LOW(0)
	LDS  R26,_TSHTL
	LDS  R27,_TSHTL+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _SHT_Teplota_ADC,R30
	STS  _SHT_Teplota_ADC+1,R31
; 0000 029F        SHT_Teplota=(konst_A+(konst_B*(SHT_Teplota_ADC/konstADCSHT)))-3.5;
	CALL SUBOPT_0x36
	LDS  R26,_SHT_Teplota_ADC
	LDS  R27,_SHT_Teplota_ADC+1
	CALL SUBOPT_0x20
	CALL __DIVF21
	LDS  R26,_konst_B
	LDS  R27,_konst_B+1
	LDS  R24,_konst_B+2
	LDS  R25,_konst_B+3
	CALL __MULF12
	LDS  R26,_konst_A
	LDS  R27,_konst_A+1
	LDS  R24,_konst_A+2
	LDS  R25,_konst_A+3
	CALL SUBOPT_0x28
	__GETD1N 0x40600000
	CALL SUBOPT_0x1B
	STS  _SHT_Teplota,R30
	STS  _SHT_Teplota+1,R31
	STS  _SHT_Teplota+2,R22
	STS  _SHT_Teplota+3,R23
; 0000 02A0        ftoa(SHT_Teplota,1,SHTTeplotastring);
	CALL SUBOPT_0x2B
	LDI  R30,LOW(_SHTTeplotastring)
	LDI  R31,HIGH(_SHTTeplotastring)
	CALL SUBOPT_0x17
; 0000 02A1 
; 0000 02A2        SHT25_Hum();
	RCALL _SHT25_Hum
; 0000 02A3        SHT_Humidity_ADC =(HSHTH*256)+HSHTL;
	LDS  R31,_HSHTH
	LDI  R30,LOW(0)
	LDS  R26,_HSHTL
	LDS  R27,_HSHTL+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _SHT_Humidity_ADC,R30
	STS  _SHT_Humidity_ADC+1,R31
; 0000 02A4        SHT_Humidity=(konst_C+(konst_D*(SHT_Humidity_ADC/konstADCSHT)));
	CALL SUBOPT_0x36
	LDS  R26,_SHT_Humidity_ADC
	LDS  R27,_SHT_Humidity_ADC+1
	CALL SUBOPT_0x20
	CALL __DIVF21
	LDS  R26,_konst_D
	LDS  R27,_konst_D+1
	LDS  R24,_konst_D+2
	LDS  R25,_konst_D+3
	CALL __MULF12
	LDS  R26,_konst_C
	LDS  R27,_konst_C+1
	LDS  R24,_konst_C+2
	LDS  R25,_konst_C+3
	CALL __ADDF12
	STS  _SHT_Humidity,R30
	STS  _SHT_Humidity+1,R31
	STS  _SHT_Humidity+2,R22
	STS  _SHT_Humidity+3,R23
; 0000 02A5        ftoa(SHT_Humidity,1,SHTHumiditystring);
	CALL SUBOPT_0x2B
	LDI  R30,LOW(_SHTHumiditystring)
	LDI  R31,HIGH(_SHTHumiditystring)
	CALL SUBOPT_0x17
; 0000 02A6 
; 0000 02A7       // Analogov vstup operativn teploty
; 0000 02A8        ToDAC=102.4*To;
	CALL SUBOPT_0x35
	__GETD2N 0x42CCCCCD
	CALL __MULF12
	LDI  R26,LOW(_ToDAC)
	LDI  R27,HIGH(_ToDAC)
	CALL __CFD1U
	ST   X+,R30
	ST   X,R31
; 0000 02A9        DAC(ToDAC);
	LDS  R30,_ToDAC
	LDS  R31,_ToDAC+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _DAC
; 0000 02AA 
; 0000 02AB      if (vyber==10)
	CALL SUBOPT_0x13
	SBIW R26,10
	BREQ PC+3
	JMP _0x3B
; 0000 02AC       {
; 0000 02AD        if (s != old)
	LDS  R30,_old
	LDS  R26,_s
	CP   R30,R26
	BREQ _0x3C
; 0000 02AE        {
; 0000 02AF            sprintf(lcd_buffer_Date, "Date %02d/%02d/20%02d ", date, month, year);
	LDI  R30,LOW(_lcd_buffer_Date)
	LDI  R31,HIGH(_lcd_buffer_Date)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,69
	CALL SUBOPT_0x37
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3A
; 0000 02B0            lcd_gotoxy(0, 0);
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 02B1            lcd_puts(lcd_buffer_Date);
	LDI  R30,LOW(_lcd_buffer_Date)
	LDI  R31,HIGH(_lcd_buffer_Date)
	CALL SUBOPT_0x10
; 0000 02B2 
; 0000 02B3            old = s;
	LDS  R30,_s
	STS  _old,R30
; 0000 02B4 
; 0000 02B5            sprintf(lcd_buffer_Time, "Time %02d:%02d:%02d   ", h, m, s);
	LDI  R30,LOW(_lcd_buffer_Time)
	LDI  R31,HIGH(_lcd_buffer_Time)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,92
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3A
; 0000 02B6            lcd_gotoxy(0, 1);
	CALL SUBOPT_0x3E
; 0000 02B7            lcd_puts(lcd_buffer_Time);
	LDI  R30,LOW(_lcd_buffer_Time)
	LDI  R31,HIGH(_lcd_buffer_Time)
	CALL SUBOPT_0x10
; 0000 02B8        }
; 0000 02B9 
; 0000 02BA             lcd_gotoxy(0,2);
_0x3C:
	CALL SUBOPT_0x3F
; 0000 02BB             lcd_puts("Operativni tepl ");
	__POINTW1MN _0x20,51
	CALL SUBOPT_0x10
; 0000 02BC 
; 0000 02BD             sprintf(lcd_buffer_Toper,"   To: %s     ",Tostring);
	LDI  R30,LOW(_lcd_buffer_Toper)
	LDI  R31,HIGH(_lcd_buffer_Toper)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,132
	CALL SUBOPT_0x40
	CALL SUBOPT_0x11
; 0000 02BE             lcd_gotoxy(0,3);
; 0000 02BF             lcd_puts(lcd_buffer_Toper);
	LDI  R30,LOW(_lcd_buffer_Toper)
	LDI  R31,HIGH(_lcd_buffer_Toper)
	CALL SUBOPT_0x10
; 0000 02C0       }
; 0000 02C1 
; 0000 02C2 
; 0000 02C3         if (vyber==1)
_0x3B:
	CALL SUBOPT_0x13
	SBIW R26,1
	BREQ PC+3
	JMP _0x3D
; 0000 02C4       {
; 0000 02C5         sprintf(lcd_buffer_Trad,"Trad: %s C    ",Tradstring);
	LDI  R30,LOW(_lcd_buffer_Trad)
	LDI  R31,HIGH(_lcd_buffer_Trad)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,147
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x41
	CALL SUBOPT_0x42
; 0000 02C6         lcd_gotoxy(0,0);
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 02C7         lcd_puts(lcd_buffer_Trad);
	LDI  R30,LOW(_lcd_buffer_Trad)
	LDI  R31,HIGH(_lcd_buffer_Trad)
	CALL SUBOPT_0x10
; 0000 02C8         sprintf(lcd_buffer_Tokoli,"Tokol: %s C   ",SHTTeplotastring);
	LDI  R30,LOW(_lcd_buffer_Tokoli)
	LDI  R31,HIGH(_lcd_buffer_Tokoli)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,162
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x43
	CALL SUBOPT_0x42
; 0000 02C9         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 02CA         lcd_puts(lcd_buffer_Tokoli);
	LDI  R30,LOW(_lcd_buffer_Tokoli)
	LDI  R31,HIGH(_lcd_buffer_Tokoli)
	CALL SUBOPT_0x10
; 0000 02CB         sprintf(lcd_buffer_Proudeni,"Proud: %s m/s ",Proudenistring);
	LDI  R30,LOW(_lcd_buffer_Proudeni)
	LDI  R31,HIGH(_lcd_buffer_Proudeni)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,177
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x44
	CALL SUBOPT_0x42
; 0000 02CC         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 02CD         lcd_puts(lcd_buffer_Proudeni);
	LDI  R30,LOW(_lcd_buffer_Proudeni)
	LDI  R31,HIGH(_lcd_buffer_Proudeni)
	CALL SUBOPT_0x10
; 0000 02CE         sprintf(lcd_buffer_SHTTep,"Vlhkost: %s %% ",SHTHumiditystring);
	LDI  R30,LOW(_lcd_buffer_SHTTep)
	LDI  R31,HIGH(_lcd_buffer_SHTTep)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,192
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_SHTHumiditystring)
	LDI  R31,HIGH(_SHTHumiditystring)
	CALL SUBOPT_0x45
; 0000 02CF         lcd_gotoxy(0,3);
; 0000 02D0         lcd_puts(lcd_buffer_SHTTep);
	LDI  R30,LOW(_lcd_buffer_SHTTep)
	LDI  R31,HIGH(_lcd_buffer_SHTTep)
	CALL SUBOPT_0x10
; 0000 02D1       }
; 0000 02D2 
; 0000 02D3 
; 0000 02D4 
; 0000 02D5         if (vyber==2)
_0x3D:
	CALL SUBOPT_0x13
	SBIW R26,2
	BREQ PC+3
	JMP _0x3E
; 0000 02D6       {
; 0000 02D7 
; 0000 02D8 
; 0000 02D9         sprintf(lcd_buffer_Frek,"F: %s Hz   ",Frekstring);
	LDI  R30,LOW(_lcd_buffer_Frek)
	LDI  R31,HIGH(_lcd_buffer_Frek)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,208
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Frekstring)
	LDI  R31,HIGH(_Frekstring)
	CALL SUBOPT_0x46
; 0000 02DA         lcd_gotoxy(0,0);
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 02DB         lcd_puts(lcd_buffer_Frek);
	LDI  R30,LOW(_lcd_buffer_Frek)
	LDI  R31,HIGH(_lcd_buffer_Frek)
	CALL SUBOPT_0x10
; 0000 02DC         sprintf(lcd_buffer_NapetiTokoli,"Napeti_ok:%s V ",NapetiA2string);
	LDI  R30,LOW(_lcd_buffer_NapetiTokoli)
	LDI  R31,HIGH(_lcd_buffer_NapetiTokoli)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,220
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_NapetiA2string)
	LDI  R31,HIGH(_NapetiA2string)
	CALL SUBOPT_0x46
; 0000 02DD         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 02DE         lcd_puts(lcd_buffer_NapetiTokoli);
	LDI  R30,LOW(_lcd_buffer_NapetiTokoli)
	LDI  R31,HIGH(_lcd_buffer_NapetiTokoli)
	CALL SUBOPT_0x10
; 0000 02DF         sprintf(lcd_buffer_NapetiTrad,"Napeti_ra:%s V",NapetiA1string);
	LDI  R30,LOW(_lcd_buffer_NapetiTrad)
	LDI  R31,HIGH(_lcd_buffer_NapetiTrad)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,236
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_NapetiA1string)
	LDI  R31,HIGH(_NapetiA1string)
	CALL SUBOPT_0x46
; 0000 02E0         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 02E1         lcd_puts(lcd_buffer_NapetiTrad);
	LDI  R30,LOW(_lcd_buffer_NapetiTrad)
	LDI  R31,HIGH(_lcd_buffer_NapetiTrad)
	CALL SUBOPT_0x10
; 0000 02E2         sprintf(lcd_buffer_SHTHum,"Teplokoli: %s ",Tokolistring);
	LDI  R30,LOW(_lcd_buffer_SHTHum)
	LDI  R31,HIGH(_lcd_buffer_SHTHum)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,251
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Tokolistring)
	LDI  R31,HIGH(_Tokolistring)
	CALL SUBOPT_0x45
; 0000 02E3         lcd_gotoxy(0,3);
; 0000 02E4         lcd_puts(lcd_buffer_SHTHum);
	LDI  R30,LOW(_lcd_buffer_SHTHum)
	LDI  R31,HIGH(_lcd_buffer_SHTHum)
	CALL SUBOPT_0x10
; 0000 02E5       }
; 0000 02E6 
; 0000 02E7        if (vyber==3)
_0x3E:
	CALL SUBOPT_0x13
	SBIW R26,3
	BREQ PC+3
	JMP _0x3F
; 0000 02E8       {
; 0000 02E9         sprintf(lcd_buffer_ADC_A2,"ADC_A2: %d    ",ADC_A2);
	LDI  R30,LOW(_lcd_buffer_ADC_A2)
	LDI  R31,HIGH(_lcd_buffer_ADC_A2)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,266
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R12
	CALL SUBOPT_0x46
; 0000 02EA         lcd_gotoxy(0,0);
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 02EB         lcd_puts(lcd_buffer_ADC_A2);
	LDI  R30,LOW(_lcd_buffer_ADC_A2)
	LDI  R31,HIGH(_lcd_buffer_ADC_A2)
	CALL SUBOPT_0x10
; 0000 02EC 
; 0000 02ED         sprintf(lcd_buffer_ADC_A1,"ADC_A1: %d    ",ADC_A1);
	LDI  R30,LOW(_lcd_buffer_ADC_A1)
	LDI  R31,HIGH(_lcd_buffer_ADC_A1)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,281
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R10
	CALL SUBOPT_0x46
; 0000 02EE         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 02EF         lcd_puts(lcd_buffer_ADC_A1);
	LDI  R30,LOW(_lcd_buffer_ADC_A1)
	LDI  R31,HIGH(_lcd_buffer_ADC_A1)
	CALL SUBOPT_0x10
; 0000 02F0 
; 0000 02F1         sprintf(lcd_buffer_ADC_SHT,"SHT_T: %d    ",SHT_Teplota_ADC);
	LDI  R30,LOW(_lcd_buffer_ADC_SHT)
	LDI  R31,HIGH(_lcd_buffer_ADC_SHT)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,296
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_SHT_Teplota_ADC
	LDS  R31,_SHT_Teplota_ADC+1
	CALL SUBOPT_0x46
; 0000 02F2         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 02F3         lcd_puts(lcd_buffer_ADC_SHT);
	LDI  R30,LOW(_lcd_buffer_ADC_SHT)
	LDI  R31,HIGH(_lcd_buffer_ADC_SHT)
	CALL SUBOPT_0x10
; 0000 02F4 
; 0000 02F5         sprintf(lcd_buffer_ADC_SHT,"SHT_H: %d    ",SHT_Humidity_ADC);
	LDI  R30,LOW(_lcd_buffer_ADC_SHT)
	LDI  R31,HIGH(_lcd_buffer_ADC_SHT)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,310
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_SHT_Humidity_ADC
	LDS  R31,_SHT_Humidity_ADC+1
	CALL SUBOPT_0x45
; 0000 02F6         lcd_gotoxy(0,3);
; 0000 02F7         lcd_puts(lcd_buffer_ADC_SHT);
	LDI  R30,LOW(_lcd_buffer_ADC_SHT)
	LDI  R31,HIGH(_lcd_buffer_ADC_SHT)
	CALL SUBOPT_0x10
; 0000 02F8       }
; 0000 02F9 
; 0000 02FA 
; 0000 02FB 
; 0000 02FC       if (vyber==4)
_0x3F:
	CALL SUBOPT_0x13
	SBIW R26,4
	BREQ PC+3
	JMP _0x40
; 0000 02FD         {
; 0000 02FE 
; 0000 02FF         if (KEY_PRESSED_PLUS & h<23)
	CALL SUBOPT_0x47
	LDS  R26,_h
	LDI  R30,LOW(23)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0x41
; 0000 0300         {
; 0000 0301         h=h+1;
	LDS  R30,_h
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x48
; 0000 0302         delay_ms(1);
; 0000 0303         rtc_set_time(h,m,s);
	CALL SUBOPT_0x49
; 0000 0304 
; 0000 0305         }
; 0000 0306 
; 0000 0307         if (KEY_PRESSED_MINUS & h>0)
_0x41:
	CALL SUBOPT_0x4A
	LDS  R26,_h
	CALL SUBOPT_0x4B
	BREQ _0x42
; 0000 0308         {
; 0000 0309         h=h-1;
	LDS  R30,_h
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x48
; 0000 030A         delay_ms(1);
; 0000 030B         rtc_set_time(h,m,s);
	CALL SUBOPT_0x49
; 0000 030C         }
; 0000 030D 
; 0000 030E 
; 0000 030F         lcd_gotoxy(0,0);
_0x42:
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 0310         lcd_puts("Nastaveni casu");
	__POINTW1MN _0x20,68
	CALL SUBOPT_0x10
; 0000 0311 
; 0000 0312         sprintf(lcd_buffer_Hodiny,"Hodiny: %d <    ",h);
	CALL SUBOPT_0x4D
	__POINTW1FN _0x0,339
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x42
; 0000 0313         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 0314         lcd_puts(lcd_buffer_Hodiny);
	CALL SUBOPT_0x4E
; 0000 0315 
; 0000 0316         sprintf(lcd_buffer_Minuty,"Minuty: %d       ",m);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x50
	CALL SUBOPT_0x42
; 0000 0317         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 0318         lcd_puts(lcd_buffer_Minuty);
	CALL SUBOPT_0x51
; 0000 0319 
; 0000 031A         sprintf(lcd_buffer_Sekundy,"Sekundy: %d     ",s);
	CALL SUBOPT_0x52
	CALL SUBOPT_0x11
; 0000 031B         lcd_gotoxy(0,3);
; 0000 031C         lcd_puts(lcd_buffer_Sekundy);
	CALL SUBOPT_0x53
; 0000 031D         }
; 0000 031E 
; 0000 031F          if (vyber==5)
_0x40:
	CALL SUBOPT_0x13
	SBIW R26,5
	BREQ PC+3
	JMP _0x43
; 0000 0320         {
; 0000 0321 
; 0000 0322         if (KEY_PRESSED_PLUS & m<59)
	CALL SUBOPT_0x47
	LDS  R26,_m
	LDI  R30,LOW(59)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0x44
; 0000 0323         {
; 0000 0324         m=m+1;
	LDS  R30,_m
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x54
; 0000 0325         delay_ms(1);
; 0000 0326         rtc_set_time(h,m,s);
	CALL SUBOPT_0x49
; 0000 0327 
; 0000 0328         }
; 0000 0329 
; 0000 032A         if (KEY_PRESSED_MINUS & m>0)
_0x44:
	CALL SUBOPT_0x4A
	LDS  R26,_m
	CALL SUBOPT_0x4B
	BREQ _0x45
; 0000 032B         {
; 0000 032C         m=m-1;
	LDS  R30,_m
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x54
; 0000 032D         delay_ms(1);
; 0000 032E         rtc_set_time(h,m,s);
	CALL SUBOPT_0x49
; 0000 032F         }
; 0000 0330 
; 0000 0331         lcd_gotoxy(0,0);
_0x45:
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 0332         lcd_puts("Nastaveni casu");
	__POINTW1MN _0x20,83
	CALL SUBOPT_0x10
; 0000 0333 
; 0000 0334         sprintf(lcd_buffer_Hodiny,"Hodiny: %d      ",h);
	CALL SUBOPT_0x4D
	__POINTW1FN _0x0,391
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x42
; 0000 0335         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 0336         lcd_puts(lcd_buffer_Hodiny);
	CALL SUBOPT_0x4E
; 0000 0337 
; 0000 0338         sprintf(lcd_buffer_Minuty,"Minuty: %d <     ",m);
	CALL SUBOPT_0x4F
	__POINTW1FN _0x0,408
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x42
; 0000 0339         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 033A         lcd_puts(lcd_buffer_Minuty);
	CALL SUBOPT_0x51
; 0000 033B 
; 0000 033C         sprintf(lcd_buffer_Sekundy,"Sekundy: %d     ",s);
	CALL SUBOPT_0x52
	CALL SUBOPT_0x11
; 0000 033D         lcd_gotoxy(0,3);
; 0000 033E         lcd_puts(lcd_buffer_Sekundy);
	CALL SUBOPT_0x53
; 0000 033F 
; 0000 0340       }
; 0000 0341 
; 0000 0342       if (vyber==6)
_0x43:
	CALL SUBOPT_0x13
	SBIW R26,6
	BREQ PC+3
	JMP _0x46
; 0000 0343         {
; 0000 0344 
; 0000 0345         if (KEY_PRESSED_PLUS & s<59)
	CALL SUBOPT_0x47
	LDS  R26,_s
	LDI  R30,LOW(59)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0x47
; 0000 0346         {
; 0000 0347         s=s+1;
	LDS  R30,_s
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x55
; 0000 0348         delay_ms(1);
; 0000 0349         rtc_set_time(h,m,s);
	CALL SUBOPT_0x49
; 0000 034A 
; 0000 034B         }
; 0000 034C 
; 0000 034D         if (KEY_PRESSED_MINUS & s>0)
_0x47:
	CALL SUBOPT_0x4A
	LDS  R26,_s
	CALL SUBOPT_0x4B
	BREQ _0x48
; 0000 034E         {
; 0000 034F         s=s-1;
	LDS  R30,_s
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x55
; 0000 0350         delay_ms(1);
; 0000 0351         rtc_set_time(h,m,s);
	CALL SUBOPT_0x49
; 0000 0352         }
; 0000 0353 
; 0000 0354 
; 0000 0355         lcd_gotoxy(0,0);
_0x48:
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 0356         lcd_puts("Nastaveni casu");
	__POINTW1MN _0x20,98
	CALL SUBOPT_0x10
; 0000 0357 
; 0000 0358         sprintf(lcd_buffer_Hodiny,"Hodiny: %d      ",h);
	CALL SUBOPT_0x4D
	__POINTW1FN _0x0,391
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x42
; 0000 0359         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 035A         lcd_puts(lcd_buffer_Hodiny);
	CALL SUBOPT_0x4E
; 0000 035B 
; 0000 035C         sprintf(lcd_buffer_Minuty,"Minuty: %d       ",m);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x50
	CALL SUBOPT_0x42
; 0000 035D         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 035E         lcd_puts(lcd_buffer_Minuty);
	CALL SUBOPT_0x51
; 0000 035F 
; 0000 0360         sprintf(lcd_buffer_Sekundy,"Sekundy: %d <   ",s);
	LDI  R30,LOW(_lcd_buffer_Sekundy)
	LDI  R31,HIGH(_lcd_buffer_Sekundy)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,426
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x11
; 0000 0361         lcd_gotoxy(0,3);
; 0000 0362         lcd_puts(lcd_buffer_Sekundy);
	CALL SUBOPT_0x53
; 0000 0363 
; 0000 0364       }
; 0000 0365 
; 0000 0366       if (vyber==7)
_0x46:
	CALL SUBOPT_0x13
	SBIW R26,7
	BREQ PC+3
	JMP _0x49
; 0000 0367         {
; 0000 0368 
; 0000 0369         if (KEY_PRESSED_PLUS & date<30)
	CALL SUBOPT_0x47
	LDS  R26,_date
	LDI  R30,LOW(30)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0x4A
; 0000 036A         {
; 0000 036B         date=date+1;
	LDS  R30,_date
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x56
; 0000 036C         delay_ms(1);
; 0000 036D         rtc_set_date(date,month,year);
	CALL SUBOPT_0x57
; 0000 036E 
; 0000 036F         }
; 0000 0370 
; 0000 0371         if (KEY_PRESSED_MINUS & date>1)
_0x4A:
	CALL SUBOPT_0x4A
	LDS  R26,_date
	LDI  R30,LOW(1)
	CALL __GTB12U
	AND  R30,R0
	BREQ _0x4B
; 0000 0372         {
; 0000 0373         date=date-1;
	LDS  R30,_date
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x56
; 0000 0374         delay_ms(1);
; 0000 0375         rtc_set_date(date,month,year);
	CALL SUBOPT_0x57
; 0000 0376         }
; 0000 0377 
; 0000 0378 
; 0000 0379         lcd_gotoxy(0,0);
_0x4B:
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 037A         lcd_puts("Nastaveni data");
	__POINTW1MN _0x20,113
	CALL SUBOPT_0x10
; 0000 037B 
; 0000 037C         sprintf(lcd_buffer_Datum,"Datum: %d <     ",date);
	CALL SUBOPT_0x58
	__POINTW1FN _0x0,458
	CALL SUBOPT_0x37
	CALL SUBOPT_0x42
; 0000 037D         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 037E         lcd_puts(lcd_buffer_Datum);
	CALL SUBOPT_0x59
; 0000 037F 
; 0000 0380         sprintf(lcd_buffer_Mesic,"Mesic: %d       ",month);
	CALL SUBOPT_0x5A
	__POINTW1FN _0x0,475
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x42
; 0000 0381         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 0382         lcd_puts(lcd_buffer_Mesic);
	CALL SUBOPT_0x5C
; 0000 0383 
; 0000 0384         sprintf(lcd_buffer_Rok,"Rok: 20%d       ",year);
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x11
; 0000 0385         lcd_gotoxy(0,3);
; 0000 0386         lcd_puts(lcd_buffer_Rok);
	CALL SUBOPT_0x5E
; 0000 0387 
; 0000 0388       }
; 0000 0389 
; 0000 038A        if (vyber==8)
_0x49:
	CALL SUBOPT_0x13
	SBIW R26,8
	BREQ PC+3
	JMP _0x4C
; 0000 038B         {
; 0000 038C 
; 0000 038D         if (KEY_PRESSED_PLUS & month<11)
	CALL SUBOPT_0x47
	LDS  R26,_month
	LDI  R30,LOW(11)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0x4D
; 0000 038E         {
; 0000 038F         month=month+1;
	LDS  R30,_month
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x5F
; 0000 0390         delay_ms(1);
; 0000 0391         rtc_set_date(date,month,year);
	CALL SUBOPT_0x57
; 0000 0392 
; 0000 0393         }
; 0000 0394 
; 0000 0395         if (KEY_PRESSED_MINUS & month>1)
_0x4D:
	CALL SUBOPT_0x4A
	LDS  R26,_month
	LDI  R30,LOW(1)
	CALL __GTB12U
	AND  R30,R0
	BREQ _0x4E
; 0000 0396         {
; 0000 0397         month=month-1;
	LDS  R30,_month
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x5F
; 0000 0398         delay_ms(1);
; 0000 0399         rtc_set_date(date,month,year);
	CALL SUBOPT_0x57
; 0000 039A         }
; 0000 039B 
; 0000 039C 
; 0000 039D         lcd_gotoxy(0,0);
_0x4E:
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 039E         lcd_puts("Nastaveni data");
	__POINTW1MN _0x20,128
	CALL SUBOPT_0x10
; 0000 039F 
; 0000 03A0         sprintf(lcd_buffer_Datum,"Datum: %d       ",date);
	CALL SUBOPT_0x58
	__POINTW1FN _0x0,509
	CALL SUBOPT_0x37
	CALL SUBOPT_0x42
; 0000 03A1         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 03A2         lcd_puts(lcd_buffer_Datum);
	CALL SUBOPT_0x59
; 0000 03A3 
; 0000 03A4         sprintf(lcd_buffer_Mesic,"Mesic: %d <      ",month);
	CALL SUBOPT_0x5A
	__POINTW1FN _0x0,526
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x42
; 0000 03A5         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 03A6         lcd_puts(lcd_buffer_Mesic);
	CALL SUBOPT_0x5C
; 0000 03A7 
; 0000 03A8         sprintf(lcd_buffer_Rok,"Rok: 20%d       ",year);
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x11
; 0000 03A9         lcd_gotoxy(0,3);
; 0000 03AA         lcd_puts(lcd_buffer_Rok);
	CALL SUBOPT_0x5E
; 0000 03AB 
; 0000 03AC       }
; 0000 03AD 
; 0000 03AE       if (vyber==9)
_0x4C:
	CALL SUBOPT_0x13
	SBIW R26,9
	BREQ PC+3
	JMP _0x4F
; 0000 03AF         {
; 0000 03B0 
; 0000 03B1         if (KEY_PRESSED_PLUS & year<konst_Rok_Max)
	CALL SUBOPT_0x47
	LDS  R30,_konst_Rok_Max
	LDS  R31,_konst_Rok_Max+1
	LDS  R26,_year
	LDI  R27,0
	CALL __LTW12U
	AND  R30,R0
	BREQ _0x50
; 0000 03B2         {
; 0000 03B3         year=year+1;
	LDS  R30,_year
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x60
; 0000 03B4         delay_ms(1);
; 0000 03B5         rtc_set_date(date,month,year);
	CALL SUBOPT_0x57
; 0000 03B6 
; 0000 03B7         }
; 0000 03B8 
; 0000 03B9         if (KEY_PRESSED_MINUS & month>konst_Rok_Min)
_0x50:
	CALL SUBOPT_0x4A
	LDS  R30,_konst_Rok_Min
	LDS  R31,_konst_Rok_Min+1
	LDS  R26,_month
	LDI  R27,0
	CALL __GTW12U
	AND  R30,R0
	BREQ _0x51
; 0000 03BA         {
; 0000 03BB         year=year-1;
	LDS  R30,_year
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x60
; 0000 03BC         delay_ms(1);
; 0000 03BD         rtc_set_date(date,month,year);
	CALL SUBOPT_0x57
; 0000 03BE         }
; 0000 03BF 
; 0000 03C0 
; 0000 03C1         lcd_gotoxy(0,0);
_0x51:
	CALL SUBOPT_0xC
	CALL _lcd_gotoxy
; 0000 03C2         lcd_puts("Nastaveni data");
	__POINTW1MN _0x20,143
	CALL SUBOPT_0x10
; 0000 03C3 
; 0000 03C4         sprintf(lcd_buffer_Datum,"Datum: %d       ",date);
	CALL SUBOPT_0x58
	__POINTW1FN _0x0,509
	CALL SUBOPT_0x37
	CALL SUBOPT_0x42
; 0000 03C5         lcd_gotoxy(0,1);
	CALL SUBOPT_0x3E
; 0000 03C6         lcd_puts(lcd_buffer_Datum);
	CALL SUBOPT_0x59
; 0000 03C7 
; 0000 03C8         sprintf(lcd_buffer_Mesic,"Mesic: %d        ",month);
	CALL SUBOPT_0x5A
	__POINTW1FN _0x0,544
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x42
; 0000 03C9         lcd_gotoxy(0,2);
	CALL SUBOPT_0x3F
; 0000 03CA         lcd_puts(lcd_buffer_Mesic);
	CALL SUBOPT_0x5C
; 0000 03CB 
; 0000 03CC         sprintf(lcd_buffer_Rok,"Rok: 20%d <     ",year);
	LDI  R30,LOW(_lcd_buffer_Rok)
	LDI  R31,HIGH(_lcd_buffer_Rok)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,562
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x39
	CALL SUBOPT_0x11
; 0000 03CD         lcd_gotoxy(0,3);
; 0000 03CE         lcd_puts(lcd_buffer_Rok);
	CALL SUBOPT_0x5E
; 0000 03CF 
; 0000 03D0       }
; 0000 03D1 
; 0000 03D2         if(rx_counter0)
_0x4F:
	LDS  R30,_rx_counter0
	CPI  R30,0
	BREQ _0x52
; 0000 03D3         {
; 0000 03D4           znak=getchar();
	CALL _getchar
	STS  _znak,R30
; 0000 03D5           if(znak == 'a')
	LDS  R26,_znak
	CPI  R26,LOW(0x61)
	BRNE _0x53
; 0000 03D6           {
; 0000 03D7            sprintf(uart_buffer,"Data:To:%s:Tr:%s:Tok:%s:w:%s:Tok2:%s:Hum:%s",Tostring,Tradstring,Tokolistring,Proudenistring,SHTTeplotastring,SHTHumiditystring);
	LDI  R30,LOW(_uart_buffer)
	LDI  R31,HIGH(_uart_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,579
	CALL SUBOPT_0x40
	CALL __PUTPARD1
	CALL SUBOPT_0x41
	LDI  R30,LOW(_Tokolistring)
	LDI  R31,HIGH(_Tokolistring)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	CALL SUBOPT_0x44
	CALL SUBOPT_0x43
	LDI  R30,LOW(_SHTHumiditystring)
	LDI  R31,HIGH(_SHTHumiditystring)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,24
	RCALL _sprintf
	ADIW R28,28
; 0000 03D8            puts(uart_buffer);
	LDI  R30,LOW(_uart_buffer)
	LDI  R31,HIGH(_uart_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _puts
; 0000 03D9           }
; 0000 03DA         }
_0x53:
; 0000 03DB       }
_0x52:
	ADIW R28,12
	JMP  _0x24
; 0000 03DC }
_0x54:
	RJMP _0x54

	.DSEG
_0x20:
	.BYTE 0x9E
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_puts:
	ST   -Y,R17
_0x2000003:
	CALL SUBOPT_0x61
	BREQ _0x2000005
	ST   -Y,R17
	CALL _putchar
	RJMP _0x2000003
_0x2000005:
	LDI  R30,LOW(10)
	ST   -Y,R30
	CALL _putchar
	JMP  _0x2100003
_put_buff_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x2
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	CALL SUBOPT_0x2
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	CALL SUBOPT_0x62
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	CALL SUBOPT_0x62
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	CALL SUBOPT_0x63
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x64
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	CALL SUBOPT_0x63
	CALL SUBOPT_0x65
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	CALL SUBOPT_0x63
	CALL SUBOPT_0x65
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	CALL SUBOPT_0x63
	CALL SUBOPT_0x66
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	CALL SUBOPT_0x63
	CALL SUBOPT_0x66
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	CALL SUBOPT_0x62
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	CALL SUBOPT_0x62
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x64
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	CALL SUBOPT_0x62
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x64
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x67
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2100008
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x67
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2100008:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	CALL SUBOPT_0x68
	CALL __PUTPARD1
	CALL _ftrunc
	CALL __PUTD1S0
    brne __floor1
__floor0:
	CALL SUBOPT_0x68
	RJMP _0x2100007
__floor1:
    brtc __floor0
	CALL SUBOPT_0x68
	__GETD2N 0x3F800000
	CALL __SUBF12
_0x2100007:
	ADIW R28,4
	RET

	.CSEG
_ftoa:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x204000D
	CALL SUBOPT_0x69
	__POINTW1FN _0x2040000,0
	CALL SUBOPT_0x6A
	RJMP _0x2100006
_0x204000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x204000C
	CALL SUBOPT_0x69
	__POINTW1FN _0x2040000,1
	CALL SUBOPT_0x6A
	RJMP _0x2100006
_0x204000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x204000F
	__GETD1S 9
	CALL __ANEGF1
	CALL SUBOPT_0x6B
	CALL SUBOPT_0x6C
	LDI  R30,LOW(45)
	ST   X,R30
_0x204000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2040010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2040010:
	LDD  R17,Y+8
_0x2040011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2040013
	CALL SUBOPT_0x6D
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	RJMP _0x2040011
_0x2040013:
	CALL SUBOPT_0x70
	CALL __ADDF12
	CALL SUBOPT_0x6B
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	CALL SUBOPT_0x6F
_0x2040014:
	CALL SUBOPT_0x70
	CALL __CMPF12
	BRLO _0x2040016
	CALL SUBOPT_0x6D
	CALL SUBOPT_0x71
	CALL SUBOPT_0x6F
	SUBI R17,-LOW(1)
	CPI  R17,39
	BRLO _0x2040017
	CALL SUBOPT_0x69
	__POINTW1FN _0x2040000,5
	CALL SUBOPT_0x6A
	RJMP _0x2100006
_0x2040017:
	RJMP _0x2040014
_0x2040016:
	CPI  R17,0
	BRNE _0x2040018
	CALL SUBOPT_0x6C
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2040019
_0x2040018:
_0x204001A:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x204001C
	CALL SUBOPT_0x6D
	CALL SUBOPT_0x6E
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _floor
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x70
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x72
	CALL SUBOPT_0x6D
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	CALL SUBOPT_0x73
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x6B
	RJMP _0x204001A
_0x204001C:
_0x2040019:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x2100005
	CALL SUBOPT_0x6C
	LDI  R30,LOW(46)
	ST   X,R30
_0x204001E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x2040020
	CALL SUBOPT_0x73
	CALL SUBOPT_0x71
	CALL SUBOPT_0x6B
	__GETD1S 9
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x72
	CALL SUBOPT_0x73
	CALL __CWD1
	CALL __CDF1
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x6B
	RJMP _0x204001E
_0x2040020:
_0x2100005:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x2100006:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_rtc_init:
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2080003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x2080003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2080004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x2080004:
	CALL SUBOPT_0x74
	LDI  R30,LOW(7)
	CALL SUBOPT_0x75
	CALL SUBOPT_0x5
	RJMP _0x2100002
_rtc_get_time:
	CALL SUBOPT_0x74
	LDI  R30,LOW(0)
	CALL SUBOPT_0x76
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x77
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RJMP _0x2100004
_rtc_set_time:
	CALL SUBOPT_0x74
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL SUBOPT_0x4
	CALL SUBOPT_0x78
	CALL SUBOPT_0x75
	CALL _bin2bcd
	ST   -Y,R30
	CALL SUBOPT_0x5
	RJMP _0x2100002
_rtc_get_date:
	CALL SUBOPT_0x74
	LDI  R30,LOW(4)
	CALL SUBOPT_0x76
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL SUBOPT_0x77
	LD   R26,Y
	LDD  R27,Y+1
_0x2100004:
	ST   X,R30
	CALL _i2c_stop
	ADIW R28,6
	RET
_rtc_set_date:
	CALL SUBOPT_0x74
	LDI  R30,LOW(4)
	CALL SUBOPT_0x75
	CALL SUBOPT_0x78
	ST   -Y,R30
	CALL SUBOPT_0x4
	CALL _bin2bcd
	ST   -Y,R30
	CALL SUBOPT_0x5
	RJMP _0x2100002
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G105:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x20A0004
	SBI  0x15,4
	RJMP _0x20A0005
_0x20A0004:
	CBI  0x15,4
_0x20A0005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x20A0006
	SBI  0x15,6
	RJMP _0x20A0007
_0x20A0006:
	CBI  0x15,6
_0x20A0007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x20A0008
	SBI  0x15,7
	RJMP _0x20A0009
_0x20A0008:
	CBI  0x15,7
_0x20A0009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x20A000A
	SBI  0x15,5
	RJMP _0x20A000B
_0x20A000A:
	CBI  0x15,5
_0x20A000B:
	__DELAY_USB 10
	SBI  0x15,2
	__DELAY_USB 25
	CBI  0x15,2
	__DELAY_USB 25
	RJMP _0x2100001
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G105
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G105
	__DELAY_USB 246
	RJMP _0x2100001
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G105)
	SBCI R31,HIGH(-__base_y_G105)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x79
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0x79
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x20A0011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x20A0010
_0x20A0011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x20A0013
	RJMP _0x2100001
_0x20A0013:
_0x20A0010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x15,0
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	CBI  0x15,0
	RJMP _0x2100001
_lcd_puts:
	ST   -Y,R17
_0x20A0014:
	CALL SUBOPT_0x61
	BREQ _0x20A0016
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x20A0014
_0x20A0016:
_0x2100003:
	LDD  R17,Y+0
_0x2100002:
	ADIW R28,3
	RET
_lcd_init:
	SBI  0x14,4
	SBI  0x14,6
	SBI  0x14,7
	SBI  0x14,5
	SBI  0x14,2
	SBI  0x14,0
	SBI  0x14,1
	CBI  0x15,2
	CBI  0x15,0
	CBI  0x15,1
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G105,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G105,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0xB
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x7A
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G105
	__DELAY_USW 369
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x2100001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.DSEG
_TSHTH:
	.BYTE 0x2
_TSHTL:
	.BYTE 0x2
_TSHT2:
	.BYTE 0x2
_HSHTH:
	.BYTE 0x2
_HSHTL:
	.BYTE 0x2
_HSHT2:
	.BYTE 0x2
_counter_0:
	.BYTE 0x4
_frekvence:
	.BYTE 0x4
_lcd_buffer:
	.BYTE 0x21
_lcd_buffer_Date:
	.BYTE 0x21
_lcd_buffer_Time:
	.BYTE 0x21
_lcd_buffer_Frek:
	.BYTE 0x21
_lcd_buffer_Toper:
	.BYTE 0x21
_lcd_buffer_Tokoli:
	.BYTE 0x21
_lcd_buffer_Trad:
	.BYTE 0x21
_lcd_buffer_Proudeni:
	.BYTE 0x21
_lcd_buffer_NapetiTokoli:
	.BYTE 0x21
_lcd_buffer_NapetiTrad:
	.BYTE 0x21
_lcd_buffer_ADC_A2:
	.BYTE 0x21
_lcd_buffer_ADC_A1:
	.BYTE 0x21
_lcd_buffer_SHTTep:
	.BYTE 0x21
_lcd_buffer_SHTHum:
	.BYTE 0x21
_lcd_buffer_ADC_SHT:
	.BYTE 0x21
_lcd_buffer_Hodiny:
	.BYTE 0x21
_lcd_buffer_Minuty:
	.BYTE 0x21
_lcd_buffer_Sekundy:
	.BYTE 0x21
_lcd_buffer_Datum:
	.BYTE 0x21
_lcd_buffer_Mesic:
	.BYTE 0x21
_lcd_buffer_Rok:
	.BYTE 0x21
_Frekstring:
	.BYTE 0x21
_Tradstring:
	.BYTE 0x21
_Tokolistring:
	.BYTE 0x21
_Proudenistring:
	.BYTE 0x21
_NapetiA2string:
	.BYTE 0x21
_NapetiA1string:
	.BYTE 0x21
_SHTTeplotastring:
	.BYTE 0x21
_SHTHumiditystring:
	.BYTE 0x21
_Tostring:
	.BYTE 0x21
_uart_buffer:
	.BYTE 0x3F
_citac:
	.BYTE 0x2
_nacteno:
	.BYTE 0x2
_znak:
	.BYTE 0x1
_napeti_A1:
	.BYTE 0x4
_napeti_A2:
	.BYTE 0x4
_A:
	.BYTE 0x4
_B:
	.BYTE 0x4
_G:
	.BYTE 0x4
_h:
	.BYTE 0x1
_m:
	.BYTE 0x1
_s:
	.BYTE 0x1
_date:
	.BYTE 0x1
_month:
	.BYTE 0x1
_year:
	.BYTE 0x1
_old:
	.BYTE 0x1
_Trad:
	.BYTE 0x4
_Tokoli:
	.BYTE 0x4
_To:
	.BYTE 0x4
_konstADC:
	.BYTE 0x4
_Vref:
	.BYTE 0x4
_proudeni:
	.BYTE 0x4
_vyber:
	.BYTE 0x2
_AP:
	.BYTE 0x4
_konst_Rok_Max:
	.BYTE 0x2
_konst_Rok_Min:
	.BYTE 0x2
_SHT_Teplota:
	.BYTE 0x4
_SHT_Teplota_ADC:
	.BYTE 0x2
_SHT_Humidity:
	.BYTE 0x4
_SHT_Humidity_ADC:
	.BYTE 0x2
_konst_A:
	.BYTE 0x4
_konst_B:
	.BYTE 0x4
_konst_C:
	.BYTE 0x4
_konst_D:
	.BYTE 0x4
_konstADCSHT:
	.BYTE 0x4
_ToDAC:
	.BYTE 0x2
_konst:
	.BYTE 0x4
_frekcpu:
	.BYTE 0x4
_k:
	.BYTE 0x2
_rx_buffer0:
	.BYTE 0x8
_rx_wr_index0:
	.BYTE 0x1
_rx_rd_index0:
	.BYTE 0x1
_rx_counter0:
	.BYTE 0x1
_tx_buffer0:
	.BYTE 0x40
_tx_wr_index0:
	.BYTE 0x1
_tx_rd_index0:
	.BYTE 0x1
_tx_counter0:
	.BYTE 0x1
__seed_G102:
	.BYTE 0x4
__base_y_G105:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer0)
	SBCI R31,HIGH(-_rx_buffer0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer0)
	SBCI R31,HIGH(-_tx_buffer0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3:
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R4,R30
	CLR  R5
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R6,R30
	CLR  R7
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R8,R30
	CLR  R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	CALL _i2c_write
	JMP  _i2c_stop

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	CALL _i2c_start
	LDI  R30,LOW(128)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	LDI  R30,LOW(129)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	CALL _i2c_write
	ST   -Y,R16
	CALL _i2c_write
	ST   -Y,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 42 TIMES, CODE SIZE REDUCTION:79 WORDS
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:97 WORDS
SUBOPT_0x11:
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x13:
	LDS  R26,_vyber
	LDS  R27,_vyber+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:123 WORDS
SUBOPT_0x14:
	LDS  R26,_frekvence
	LDS  R27,_frekvence+1
	LDS  R24,_frekvence+2
	LDS  R25,_frekvence+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	STS  _frekvence,R30
	STS  _frekvence+1,R31
	STS  _frekvence+2,R22
	STS  _frekvence+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x16:
	LDS  R30,_frekvence
	LDS  R31,_frekvence+1
	LDS  R22,_frekvence+2
	LDS  R23,_frekvence+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x17:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _ftoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x14
	__GETD1N 0x43340000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	RCALL SUBOPT_0x14
	__GETD1N 0x44480000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	STS  _proudeni,R30
	STS  _proudeni+1,R31
	STS  _proudeni+2,R22
	STS  _proudeni+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x1B:
	CALL __SWAPD12
	CALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x1C:
	CALL __MULF12
	RCALL SUBOPT_0x14
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1D:
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x1C

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x1E:
	LDS  R30,_proudeni
	LDS  R31,_proudeni+1
	LDS  R22,_proudeni+2
	LDS  R23,_proudeni+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	CALL __PUTPARD1
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x20:
	CLR  R24
	CLR  R25
	CALL __CDF2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x21:
	LDS  R30,_konstADC
	LDS  R31,_konstADC+1
	LDS  R22,_konstADC+2
	LDS  R23,_konstADC+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x22:
	RCALL SUBOPT_0x20
	CALL __DIVF21
	LDS  R26,_Vref
	LDS  R27,_Vref+1
	LDS  R24,_Vref+2
	LDS  R25,_Vref+3
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x23:
	STS  _napeti_A1,R30
	STS  _napeti_A1+1,R31
	STS  _napeti_A1+2,R22
	STS  _napeti_A1+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x24:
	LDS  R26,_napeti_A1
	LDS  R27,_napeti_A1+1
	LDS  R24,_napeti_A1+2
	LDS  R25,_napeti_A1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	__GETD1N 0x40200000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x26:
	LDS  R30,_napeti_A1
	LDS  R31,_napeti_A1+1
	LDS  R22,_napeti_A1+2
	LDS  R23,_napeti_A1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x27:
	CALL __MULF12
	RJMP SUBOPT_0x24

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	CALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	STS  _Trad,R30
	STS  _Trad+1,R31
	STS  _Trad+2,R22
	STS  _Trad+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	LDS  R30,_Trad
	LDS  R31,_Trad+1
	LDS  R22,_Trad+2
	LDS  R23,_Trad+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2B:
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2C:
	STS  _napeti_A2,R30
	STS  _napeti_A2+1,R31
	STS  _napeti_A2+2,R22
	STS  _napeti_A2+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x2D:
	LDS  R26,_napeti_A2
	LDS  R27,_napeti_A2+1
	LDS  R24,_napeti_A2+2
	LDS  R25,_napeti_A2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x2E:
	LDS  R30,_napeti_A2
	LDS  R31,_napeti_A2+1
	LDS  R22,_napeti_A2+2
	LDS  R23,_napeti_A2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x2F:
	CALL __MULF12
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x30:
	LDS  R30,_Tokoli
	LDS  R31,_Tokoli+1
	LDS  R22,_Tokoli+2
	LDS  R23,_Tokoli+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:147 WORDS
SUBOPT_0x31:
	CALL __MULF12
	LDS  R26,_proudeni
	LDS  R27,_proudeni+1
	LDS  R24,_proudeni+2
	LDS  R25,_proudeni+3
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0x32:
	LDS  R26,_proudeni
	LDS  R27,_proudeni+1
	LDS  R24,_proudeni+2
	LDS  R25,_proudeni+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x33:
	RCALL SUBOPT_0x32
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	LDS  R26,_AP
	LDS  R27,_AP+1
	LDS  R24,_AP+2
	LDS  R25,_AP+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	LDS  R30,_To
	LDS  R31,_To+1
	LDS  R22,_To+2
	LDS  R23,_To+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x36:
	LDS  R30,_konstADCSHT
	LDS  R31,_konstADCSHT+1
	LDS  R22,_konstADCSHT+2
	LDS  R23,_konstADCSHT+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x37:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_date
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x38:
	LDS  R30,_month
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x39:
	LDS  R30,_year
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3A:
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x3B:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_h
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3C:
	LDS  R30,_m
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3D:
	LDS  R30,_s
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x3E:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x3F:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Tostring)
	LDI  R31,HIGH(_Tostring)
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	LDI  R30,LOW(_Tradstring)
	LDI  R31,HIGH(_Tradstring)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x42:
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(_SHTTeplotastring)
	LDI  R31,HIGH(_SHTTeplotastring)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x44:
	LDI  R30,LOW(_Proudenistring)
	LDI  R31,HIGH(_Proudenistring)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x45:
	CLR  R22
	CLR  R23
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x46:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RJMP SUBOPT_0x42

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x47:
	IN   R30,0x16
	ANDI R30,LOW(0x40)
	OUT  0x16,R30
	CALL __LNEGB1
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x48:
	STS  _h,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x49:
	LDS  R30,_h
	ST   -Y,R30
	LDS  R30,_m
	ST   -Y,R30
	LDS  R30,_s
	ST   -Y,R30
	JMP  _rtc_set_time

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x4A:
	IN   R30,0x16
	ANDI R30,LOW(0x10)
	OUT  0x16,R30
	CALL __LNEGB1
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4B:
	LDI  R30,LOW(0)
	CALL __GTB12U
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4C:
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4D:
	LDI  R30,LOW(_lcd_buffer_Hodiny)
	LDI  R31,HIGH(_lcd_buffer_Hodiny)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4E:
	LDI  R30,LOW(_lcd_buffer_Hodiny)
	LDI  R31,HIGH(_lcd_buffer_Hodiny)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4F:
	LDI  R30,LOW(_lcd_buffer_Minuty)
	LDI  R31,HIGH(_lcd_buffer_Minuty)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x50:
	__POINTW1FN _0x0,356
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x3C

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x51:
	LDI  R30,LOW(_lcd_buffer_Minuty)
	LDI  R31,HIGH(_lcd_buffer_Minuty)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x52:
	LDI  R30,LOW(_lcd_buffer_Sekundy)
	LDI  R31,HIGH(_lcd_buffer_Sekundy)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,374
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x3D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x53:
	LDI  R30,LOW(_lcd_buffer_Sekundy)
	LDI  R31,HIGH(_lcd_buffer_Sekundy)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x54:
	STS  _m,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x55:
	STS  _s,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x56:
	STS  _date,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x57:
	LDS  R30,_date
	ST   -Y,R30
	LDS  R30,_month
	ST   -Y,R30
	LDS  R30,_year
	ST   -Y,R30
	JMP  _rtc_set_date

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x58:
	LDI  R30,LOW(_lcd_buffer_Datum)
	LDI  R31,HIGH(_lcd_buffer_Datum)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x59:
	LDI  R30,LOW(_lcd_buffer_Datum)
	LDI  R31,HIGH(_lcd_buffer_Datum)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5A:
	LDI  R30,LOW(_lcd_buffer_Mesic)
	LDI  R31,HIGH(_lcd_buffer_Mesic)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5B:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5C:
	LDI  R30,LOW(_lcd_buffer_Mesic)
	LDI  R31,HIGH(_lcd_buffer_Mesic)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5D:
	LDI  R30,LOW(_lcd_buffer_Rok)
	LDI  R31,HIGH(_lcd_buffer_Rok)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,492
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5E:
	LDI  R30,LOW(_lcd_buffer_Rok)
	LDI  R31,HIGH(_lcd_buffer_Rok)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5F:
	STS  _month,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x60:
	STS  _year,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x61:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x62:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x63:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x64:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x65:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x66:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x67:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x68:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x69:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6A:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcpyf

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6B:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x6C:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6D:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6E:
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6F:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x70:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x71:
	__GETD1N 0x41200000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x72:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x73:
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x74:
	CALL _i2c_start
	LDI  R30,LOW(208)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x75:
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x76:
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	LDI  R30,LOW(209)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x77:
	ST   X,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x78:
	RCALL _bin2bcd
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	RJMP _bin2bcd

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x79:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7A:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G105
	__DELAY_USW 369
	RET


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,25
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,49
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xE66
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__LTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __LTF120
	BRCS __LTF121
__LTF120:
	CLR  R30
__LTF121:
	RET

__GTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __GTF120
	BRCC __GTF121
__GTF120:
	CLR  R30
__GTF121:
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__LTW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLO __LTW12UT
	CLR  R30
__LTW12UT:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
